package org.act.manage.controls;
import javax.servlet.jsp.tagext.*;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import java.io.*;

public class ACTTableTag
extends BodyTagSupport
{
private String mWidth = "100%";
private String mHeight;
private String mAlign = "center";

public String getWidth()
{
    return mWidth;
}

public String getHeight()
{
    return mHeight;
}

public String getAlign()
{
    return mAlign;
}

public void setWidth(String width)
{
    mWidth = width;
}

public void setHeight(String height)
{
    mHeight = height;
}

public void setAlign(String align)
{
    mAlign = align;
}

public int doStartTag() throws JspException
{
    JspWriter out = pageContext.getOut();
    try
    {
        out.print(
            "<table class=\"back_table\" cellspacing=\"0\" cellpadding=\"0\" ");
        out.print(" width=\"" + mWidth + "\" ");
        out.print(" align=\"" + mAlign + "\"");
        out.print(">\n");
        out.print("<tr>\n");
        out.print("<td>\n");
        out.print("<table class=\"front_table\" border=\"0\" width=\"100%\" cellspacing=\"1\" cellpadding=\"1\" ");
        if (mHeight != null && !mHeight.equals(""))
            out.print(" height=\"" + mHeight + "\" ");
        out.print(">\n");
    }
    catch (IOException ex)
    {
    }
    return (EVAL_BODY_INCLUDE);
}

public int doEndTag() throws JspException
{
        JspWriter out = pageContext.getOut();
    try
    {
        out.print("</table>\n");
        out.print("</td>\n");
        out.print("</tr>\n");
        out.print("</table>\n");
    }
    catch (IOException ex)
    {
    }
    return (EVAL_PAGE);
}
}
