package org.act.manage.controls;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.ArrayList;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.tagext.Tag;

public class LabelTag extends BodyTagSupport {
        
    protected String label = null;
        
    public int doStartTag() throws JspException {
                this.label = null;
                return (EVAL_BODY_BUFFERED);
    }
    
    public int doAfterBody() throws JspException {
        String label = bodyContent.getString();
        if (label != null) {
            label = label.trim();
            if (label.length() > 0)
                this.label = label;
        }
        return (SKIP_BODY);
    }
    
    public int doEndTag() throws JspException {
                Tag parent = getParent();
        if ((parent == null) || !(parent instanceof RowTag))
            throw new JspException("Must be nested in a rowTag isntance");
        RowTag row = (RowTag) parent;
                        HttpServletResponse response =
            (HttpServletResponse) pageContext.getResponse();
        row.setLabel(label);
        return (EVAL_PAGE);
    }
    
    public void release() {
        this.label = null;
    }
}
