
package org.act.manage.soap;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.xml.namespace.QName;
import org.act.manage.util.CallServer;
import org.act.manage.util.CallWfEngine;
import org.act.manage.util.ServerInfo;
import org.act.soap.util.TMConstants;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class SoapInfoDetailAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		HttpSession session = request.getSession();
		String backPage = (String) session.getAttribute("Util_SucBackUrl");
		String serverType=(String)request.getSession().getAttribute("ServerType");
		String server=(String)request.getSession().getAttribute("Server");
		String result=null;
		String uri=ServerInfo.getServerAddress(server, serverType).getAddress();
		if (serverType.equals("WSRuntime"))
		{
			try{
				String RMPNum=(String) CallServer
				.invoke("getRMPCacheNum", uri, TMConstants.XSD_STRING,
						new QName[] {}, new Object[] {});
				String num[]=RMPNum.split("#");
				result=num[3];
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		else if (serverType.equals("WorkflowEngine")) {
			try {
				String RMPNum=(String) CallWfEngine
				.invoke("getRMPCacheNum", uri, TMConstants.XSD_STRING,
						new QName[] {}, new Object[] {});
				String num[]=RMPNum.split("#");
				result=num[3];
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		else
		{
			return mapping.findForward("Fail");
		}
		
		if(result==null)
			if(session.getAttribute("SoapInfo")==null) result="0";
			else result=(String)session.getAttribute("SoapInfo");
		session.setAttribute("SoapInfo",result);
		ArrayList args=new ArrayList();
		if(session.getAttribute("SoapInfoLine")==null)
			args.add(new String(result));
		else
		{
			args=(ArrayList)session.getAttribute("SoapInfoLine");
			args.add(new String(result));
		}
			
		session.setAttribute("SoapInfoLine",args);
		String argsString[]=(String[])args.toArray(new String[0]);
		return mapping.findForward("Forward");
	}
}
