
package org.act.manage.user;
import java.util.ArrayList;
import java.util.Vector;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.ServerInfoMeta;
import org.act.manage.util.Utils;
import org.act.manage.util.XMLConfigUtil;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class PersonEditAction    extends Action
{
    public ActionForward execute(ActionMapping mapping
                                 , ActionForm form
                                 , HttpServletRequest request
                                 , HttpServletResponse servletResponse)
    {
        Cookie[] a = request.getCookies();
        request.getSession().setAttribute("Util_SucBackUrl", "user/personInfoEdit.jsp");
                String username = (String)request.getSession().getAttribute(
            "ACTAdminUser");
        try
        {
                        String filePath = Utils.mUserConfigFile;
            Document doc = XMLConfigUtil.loadDocumentFromFile(filePath);
                        Vector v = XMLConfigUtil.getElement(doc, null, "user", null);
            int i = v.size();
            Element ele = null;
            String name;
            for (int j = 0; j <= i - 1; j++)
            {
                ele = (Element)v.elementAt(j);
                name = XMLConfigUtil.getTextByPath(doc, ele, "username", null, null);
                if (username.equals(name))
                {
                    break;
                }
                if (j == i - 1)
                {
                    throw new UserException("user doesn't exist!");
                }
            }
                        String password = XMLConfigUtil.getTextByPath(doc, ele, "password", null, null);
            String remark = XMLConfigUtil.getTextByPath(doc, ele, "remark", null, null);
            String email = XMLConfigUtil.getTextByPath(doc, ele, "email", null, null);
            ArrayList xlinker = new ArrayList();
            ArrayList workflow = new ArrayList();
            boolean top = new Boolean(XMLConfigUtil.getTextByPath(doc, ele
                , "purview/top", null, null)).booleanValue();
                        UserInfoForm userInfo = new UserInfoForm();
            userInfo.setUsername(username);
            userInfo.setPassword(password);
            userInfo.setEmail(email);
            userInfo.setRemark(remark);
            userInfo.setXlinker(xlinker);
           
            userInfo.setWorkflow(workflow);
            userInfo.setTop(top);
                        request.getSession().setAttribute("userInfoForm", userInfo);
            request.getSession().setAttribute("op", "modify");
        }
        catch (Exception ex)
        {
                        String backUrl = "blank.jsp";
            request.getSession().setAttribute("Util_FailBackPage", backUrl);
            String tmp = AdminResBundle.getMessage("user.error.personinfoedit");
            tmp += " " + ex.getMessage();
            request.getSession().setAttribute("Util_ErrorInfo", tmp);
            request.getSession().setAttribute("Util_ErrorDetail"
                                              , Utils.FormatExceptionToHtml(ex));
            return mapping.findForward("Failure");
        }
        return mapping.findForward("Forward");
    }
}
