
package org.act.manage.user;
import java.util.ArrayList;
import java.util.Vector;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.ServerInfoMeta;
import org.act.manage.util.Utils;
import org.act.manage.util.XMLConfigUtil;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class UserEditAction    extends Action
{
    public ActionForward execute(ActionMapping mapping
                                 , ActionForm form
                                 , HttpServletRequest request
                                 , HttpServletResponse servletResponse)
    {
                String op = request.getParameter("op");
        String username = request.getParameter("username");
                if(op.equals("add")){
            UserInfoForm userInfoForm = new UserInfoForm();
            request.getSession().setAttribute("userInfoForm", userInfoForm);
            request.getSession().setAttribute("op", op);
            return mapping.findForward("Forward");
        }
                try
        {
                        String filePath = Utils.mUserConfigFile;
            Document doc = XMLConfigUtil.loadDocumentFromFile(filePath);
                        Vector v = XMLConfigUtil.getElement(doc, null, "user", null);
            int i = v.size();
            Element ele = null;
            String name;
            for(int j=0; j<=i-1; j++){
                ele = (Element) v.elementAt(j);
                name = XMLConfigUtil.getTextByPath(doc, ele, "username", null, null);
                if(username.equals(name)){
                    break;
                }
                if(j==i-1){
                    throw new UserException("user doesn't exist!");
                }
            }
                        String password = XMLConfigUtil.getTextByPath(doc, ele, "password", null, null);
            String remark = XMLConfigUtil.getTextByPath(doc, ele, "remark", null, null);
            String email = XMLConfigUtil.getTextByPath(doc, ele, "email", null, null);
            
            boolean top = new Boolean(XMLConfigUtil.getTextByPath(doc, ele, "purview/top", null, null)).booleanValue();
            ArrayList xlinker = new ArrayList();
            ArrayList workflow = new ArrayList();
                        Vector runtimeEles = XMLConfigUtil.getElement(doc, ele, "purview/WSRumtime", null);
            Element runtimeEle = null;
            for (int k = 0; k < runtimeEles.size(); k++)
            {
            	ServerInfoMeta sim=new ServerInfoMeta();
            	runtimeEle = (Element)runtimeEles.get(k);
            	String type = XMLConfigUtil.getTextByPath(doc, runtimeEle
	                , "pv", null, null);
	            
	            String mserver=XMLConfigUtil.getTextByPath(doc, runtimeEle
		                , "name", null, null);
	           sim.setName(mserver);
	           sim.setPurview(type);
	           xlinker.add(sim);
            }
                        Vector wfEles = XMLConfigUtil.getElement(doc, ele, "purview/Workflow", null);
            Element wf = null;
            for (int k = 0; k < wfEles.size(); k++)
            {
            	ServerInfoMeta sim=new ServerInfoMeta();
            	wf = (Element)wfEles.get(k);
            	String type = XMLConfigUtil.getTextByPath(doc, wf
	                , "pv", null, null);
	            String mserver=XMLConfigUtil.getTextByPath(doc, wf
		                , "name", null, null);
	            sim.setName(mserver);
 	           sim.setPurview(type);
 	           workflow.add(sim);
            }
                        UserInfoForm userInfo = new UserInfoForm();
            userInfo.setUsername(username);
            userInfo.setPassword(password);
            userInfo.setEmail(email);
            userInfo.setRemark(remark);
            userInfo.setXlinker(xlinker);
            
            userInfo.setWorkflow(workflow);
            userInfo.setTop(top);
                        request.getSession().setAttribute("userInfoForm", userInfo);
            request.getSession().setAttribute("op", op);
        }
        catch (Exception ex)
        {
                        String backUrl = "user/userList.do";
            request.getSession().setAttribute("Util_FailBackPage", backUrl);
            String tmp = AdminResBundle.getMessage("user.error.useredit");
            tmp += " "+ex.getMessage();
            request.getSession().setAttribute("Util_ErrorInfo", tmp);
            request.getSession().setAttribute("Util_ErrorDetail"
                                              , Utils.FormatExceptionToHtml(ex));
            return mapping.findForward("Failure");
        }
        return mapping.findForward("Forward");
    }
}
