
package org.act.manage.util;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class test {
	
	
	public static String[][] color = { { "#ff2222", "#ffaaaa", "#aa1111" },
			{ "#d0b83a", "#f2e692", "#9f8703" },
			{ "#ffdf00", "#fef195", "#ce9a31" },
			{ "#22FF22", "#aaffaa", "green" },
			{ "#ff9e00", "#ffbe08", "#bd7500" },
			{ "#799AE1", "#9aabEe", "#5778a1" },
			{ "#99c741", "#aef292", "#3e941b" },
			{ "#d0b83a", "#f2e692", "#9f8703" },
			{ "#319a00", "#66cc00", "#297110" },
			{ "#c27f34", "#d6a97b", "#82522b" },
			{ "#2222ff", "#aaaaff", "#1111aa" },
			{ "#ff2222", "#ffaaaa", "#aa1111" } }; 	
	public static String[][] colorNeg = { { "black", "#4F4F4F", "#757575" },
			{ "#1A0B0F", "#4F4F4F", "#757575" } };
	
	public static double[] data;
	
	public static double[][] data1;
	
	public static int dataNum = 0;
	
	public static double HistogramXSx = 50.0;
	
	public static double HistogramXy = 440.0;
	
	static double[] convertDataToDouble(String[] data) {
		double[] dData = new double[data.length];
		dataNum = 0;
		for (int i = 0; i < data.length; i++) {
			if (data[i] != null && !data[i].equalsIgnoreCase("")
					&& !data[i].equalsIgnoreCase(" ")) {
				dData[i] = Double.valueOf(data[i]).doubleValue();
				dataNum += 1;
			} else {
				dData[i] = new Double(0.0).doubleValue();
				dataNum += 1;
			}
		}
		return dData;
	}
	
	static double[][] convertDataToDouble(String[][] data) {
		double[][] dData = new double[data.length][data[0].length];
		dataNum = 0;
		for (int i = 0; i < data.length; i++) {
			for (int j = 0; j < data[i].length; j++) {
				if (data[i][j] != null && !data[i][j].equalsIgnoreCase("")
						&& !data[i][j].equalsIgnoreCase(" ")) {
					dData[i][j] = Double.parseDouble(data[i][j]);					dataNum += 1;
				} else {
					dData[i][j] = new Double(0.0).doubleValue();
					dataNum += 1;
				}
			}
		}
		return dData;
	}
	
	public static void createSVG(String fileRealPath, String[] pData,
			String[] pDataName) throws Exception {
		String sFile = paint(pData, pDataName);
		try {
			byte[] byteFil = sFile.getBytes("gb2312");
			File svgFile = new File(fileRealPath);
			if (svgFile.exists()) {
				svgFile.delete();
			}
			FileOutputStream fos = new FileOutputStream(svgFile);
			fos.write(byteFil);
			fos.close();
		} catch (Exception ex) {
			System.out.print(ex.getMessage());
		}
	}
	
	public static void createSVG(String fileRealPath, String[][] pData,
			String[] pDataName) {
		try {
			String sFile = paint(pData, pDataName);
			byte[] byteFil = sFile.getBytes("UTF-8");
			File svgFile = new File(fileRealPath);
			if (svgFile.exists()) {
				svgFile.delete();
			}
			FileOutputStream fos = new FileOutputStream(svgFile);
			fos.write(byteFil);
			fos.close();
		} catch (Exception ex) {
			System.out.print("createSVG:" + ex.getMessage());
		}
	}

	static double getvalueMax(double[] pData) {
				double max = pData[0];
		double min = pData[0];
		for (int i = 0; i < pData.length; i++) {
			if (pData[i] > max)
				max = pData[i];
			if (pData[i] < min)
				min = pData[i];
		}
				if (max <= 0 && min < 0) {
			min = Math.floor(min);
			double tMin = Math.abs(min);
			max = 0;
			if (tMin <= 1)
				min = -1;
			else {
				min = -(tMin < 100 ? Math.ceil(tMin / 10) * 10 : Math
						.ceil(tMin / 50) * 50);
			}
		}
				if (min < 0 && max > 0) {
			max = Math.ceil(max);
			if (max <= 1)
				max = 1;
			else {
				max = max < 100 ? Math.ceil(max / 10) * 10 : Math
						.ceil(max / 50) * 50;
			}
			min = Math.abs(Math.floor(min));
			if (min <= 1)
				min = -1;
			else {
				min = -(min < 100 ? Math.ceil(min / 10) * 10 : Math
						.ceil(min / 50) * 50);
			}
		}
				if (min >= 0 && max >= 0) {
			if (max == 0.0) {
				max = min = 0.0;
			} else {
				if (max <= 1)
					max = 1;
				else {
					max = max < 100 ? Math.ceil(max / 10) * 10 : Math
							.ceil(max / 50) * 50;
				}
			}
		}
		double absMax = Math.abs(max) > Math.abs(min) ? Math.abs(max) : Math
				.abs(min);
		return absMax;
	}
	
	static String initialize() {
				StringBuffer sFile = new StringBuffer();
		sFile.append("<?xml version='1.0' encoding='UTF-8'?>");
		sFile.append("\n");
		sFile
				.append("<!DOCTYPE svg PUBLIC '-//W3C//DTD SVG 1.0//EN' 'http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd&#39;>");
		sFile.append("\n");
		sFile
				.append("<svg width='700' height='500' viewBox='0 0 700 500' xmlns='http://www.w3.org/2000/svg&#39;>");
		sFile.append("\n");
		sFile.append("<desc>Histogram</desc>");
		sFile.append("\n");
		sFile
				.append("<rect x='0' y='0' width='700' height='500' fill='none' stroke='blue' stroke-width='1'/>");
		sFile.append("\n");
				sFile.append("<defs>");
		sFile.append("\n");
		sFile
				.append("  <marker id='Triangle' viewBox='0 0 10 10' refX='0' refY='5' markerUnits='strokeWidth' markerWidth='4' markerHeight='10' orient='auto'>");
		sFile.append("\n");
		sFile.append("   <path d='M 0 0 L 10 5 L 0 10 z'/>");
		sFile.append("\n");
		sFile.append("  </marker>");
		sFile.append("\n");
		sFile.append("  <linearGradient id='linear1'>");
		sFile.append("\n");
		sFile.append("     <stop offset='0%' stop-color='red'/>");
		sFile.append("\n");
		sFile.append("       <stop offset='30%' stop-color='white'/>");
		sFile.append("\n");
		sFile.append("       <stop offset='100%' stop-color='blue'/>");
		sFile.append("\n");
		sFile.append("    </linearGradient>");
		sFile.append("\n");
		sFile
				.append("    <filter id='MyFilter' filterUnits='userSpaceOnUse' x='0' y='0' width='100%' height='100%'>");
		sFile.append("\n");
		sFile
				.append("   <feGaussianBlur in='SourceAlpha' stdDeviation='3' result='blur'/>");
		sFile.append("\n");
		sFile
				.append("   <feOffset in='blur' dx='4' dy='4' result='offsetBlur'/>");
		sFile.append("\n");
		sFile.append("\n");
		sFile
				.append("   <feSpecularLighting in='blur' surfaceScale='.5' specularConstant='2.5' specularExponent='128' lighting-color='#bbbbbb'  result='specOut'>");
		sFile.append("\n");
		sFile.append("    <fePointLight x='-600' y='-100' z='2200'/>");
		sFile.append("\n");
		sFile.append("   </feSpecularLighting>");
		sFile.append("\n");
		sFile
				.append("   <feComposite in='specOut' in2='SourceAlpha' operator='in' result='specOut'/>");
		sFile.append("\n");
		sFile
				.append("   <feComposite in='SourceGraphic' in2='specOut' operator='arithmetic' k1='0' k2='1' k3='1' k4='0' result='litPaint'/>");
		sFile.append("\n");
		sFile.append("   <feMerge>");
		sFile.append("\n");
		sFile.append("      <feMergeNode in='offsetBlur'/>");
		sFile.append("\n");
		sFile.append("        <feMergeNode in='litPaint'/>");
		sFile.append("\n");
		sFile.append("   </feMerge>");
		sFile.append("\n");
		sFile.append("  </filter>");
		sFile.append("\n");
		sFile.append("<script type=\"text/javascript\">");
		sFile.append("\n");
		sFile.append("<![CDATA[");
		sFile.append("\n");
		sFile.append("       function showvalue(value) {");
		sFile.append("\n");
		sFile.append("        alert(value);");
		sFile.append("\n");
		sFile.append("       }");
		sFile.append("\n");
		sFile.append("]]>");
		sFile.append("\n");
		sFile.append("</script>");
		sFile.append("\n");
		sFile.append("</defs>");
		sFile.append("\n");
				sFile
				.append("<line x1='50' y1='440' x2='660' y2='440' stroke-width='2' stroke-opacity='.4' fill='blue' stroke='#333300' />");
		sFile.append("\n");
				sFile
				.append("<line x1='50' y1='440' x2='50' y2='40' stroke-width='2' stroke-opacity='.4' fill='blue' stroke='#333300' />");
		sFile.append("\n");
		sFile
				.append("<line x1='60' y1='30' x2='60' y2='430' stroke-width='0.5'  stroke='#333300'/>");
		
		for (int i = 0; i < 11; i++) {
			double tempY1 = 40 + i * 40.0; 			sFile.append("<line  x1='50' y1='" + tempY1 + "' x2='60' y2='"
					+ (tempY1 - 10) + "' stroke-width='1'  stroke='#333300'/>");
			sFile.append("<line x1='60' y1='" + (tempY1 - 10)
					+ "' x2='670' y2='" + (tempY1 - 10)
					+ "' stroke='#333300'/>");
			sFile.append("\n");
																							}
		return sFile.toString();
	}
	
	public static void mains(String[] args) {
		try {
			String[][] data = { { "54", "44", "122" }, { "", "12", "-468" },
					{ "78", "520", "10" } };
			String[] data1 = { "54", "4424.225", "12200", "-4658" };
			String[] dataName = { "Ӫҵһ", "", "III" };
			test.createSVG("d:\\t1.svg", data, dataName);
			test.createSVG("d:\\t2.svg", data1, dataName);
		} catch (Exception ex) {
			System.out.print(ex.getMessage());
		}
	}
	
	static String paint(String[] pData, String[] pDataName) throws Exception {
		StringBuffer sFile = new StringBuffer();
		data = convertDataToDouble(pData);
		double valueMM = getvalueMax(data); 		sFile.append(initialize());
				double yStep = 400.0 / valueMM;
		double xStep = (new BigDecimal(600 / pDataName.length).setScale(3,
				BigDecimal.ROUND_HALF_UP)).doubleValue();
		double colWidth = xStep / 2; 		double colWidthPre = xStep / 4; 		double colWidthNext = xStep / 4; 		
		for (int i = 0; i < pDataName.length; i++) {
			double tempX1 = i == 0 ? HistogramXSx + i * xStep : HistogramXSx
					+ i * xStep + 10; 						sFile.append("<line x1='" + tempX1 + "' y1='" + HistogramXy
					+ "' x2='" + (tempX1 + 10.0) + "' y2='"
					+ (HistogramXy - 10)
					+ "' stroke-width='1'  stroke='#333300'/>");
			sFile.append("\n");
		}
		
		int maxvalue = (int) valueMM;
		int valueX; 		String fontsize = "";
		if (maxvalue > 10000) {
			valueX = 5;
			fontsize = "11px";
		} else {
			valueX = 15;
			fontsize = "13px";
		}
		for (int i = 0; i < 10; i++) {
			sFile.append("<text x='" + valueX + "' y='" + (45 + i * 40)
					+ "' fill='black' font-family='Verdana' font-size='"
					+ fontsize + "'>");
			sFile.append("\n");
			sFile.append((maxvalue / 10) * (10 - i));
			sFile.append("\n");
			sFile.append("</text>");
			sFile.append("\n");
		}
		
		sFile.append("<g style='filter:url(#MyFilter)'>");
		sFile.append("\n");
		for (int i = 0; i < pDataName.length; i++) {
			double tempX1 = i == 0 ? HistogramXSx + i * xStep : HistogramXSx
					+ i * xStep + 10; 			double tempX2 = tempX1 + colWidthPre; 			double colHeight = Math.ceil(Math.abs(data[i]) * yStep);
			double tempY = 440 - colHeight;
			String[] colorHistogram; 			if (data[i] < 0) {
				colorHistogram = colorNeg[0];
				sFile.append(paintHistogram(colWidth, colHeight, tempX2, tempY,
						colorHistogram, data[i]));
			} else if (data[i] > 0) {
				int n = i % color.length;
				colorHistogram = color[n];
				sFile.append(paintHistogram(colWidth, colHeight, tempX2, tempY,
						colorHistogram, data[i]));
			}
			
			int n = (int) xStep / 13;			int m = pDataName[i].length() % n == 0 ? pDataName[i].length() / n
					: (int) (pDataName[i].length() / n + 1);			int l = 0;			if (m > 1) {
				sFile
						.append("<text fill='blue' font-size='15px' font-family='STFangsong'>");
				for (int j = 0; j < m; j++) {
					for (int z = 0; z < n; z++) {
						l = j * n + z;
						if (l == pDataName[i].length()) {
							break;
						}
						sFile.append("<tspan x='" + (tempX1 + z * 15) + "' y='"
								+ (460 + j * 20) + "' >");
						sFile.append(pDataName[i].substring(l, l + 1));
						sFile.append("</tspan>");
					}
					if (l == pDataName[i].length()) {
						break;
					}
				}
				sFile.append("</text>");
				sFile.append("\n");
			} else {
				sFile
						.append("<text x='"
								+ (5 + tempX1)
								+ "' y='460' fill='blue' font-size='15px' font-family='STFangsong'>"
								+ pDataName[i] + "</text>");
				sFile.append("\n");
			}
		}
		sFile.append("</g>");
		sFile.append("\n");
		sFile.append("</svg>");
		return sFile.toString();
	}
	
	static String paint(String[][] pData, String[] pDataName) {
		StringBuffer sFile = new StringBuffer();
		data1 = convertDataToDouble(pData);
				double[] tempvalue = new double[dataNum];
		for (int i = 0; i < data1.length; i++) {
			for (int j = 0; j < data1[i].length; j++) {
				tempvalue[i * data1[i].length + j] = data1[i][j];
			}
		}
		double valueMM = getvalueMax(tempvalue);
		sFile.append(initialize());
		double yStep = 400.0 / valueMM;
		double xStep = (new BigDecimal(600 / pDataName.length).setScale(3,
				BigDecimal.ROUND_HALF_UP)).doubleValue();
		double colWidthSum = xStep / 2; 		double colWidthPre = xStep / 4; 		double colWidthNext = xStep / 4; 		double colWidth = colWidthSum / data1[0].length; 		
		for (int i = 0; i < pDataName.length; i++) {
			double tempX1 = i == 0 ? HistogramXSx + i * xStep : HistogramXSx
					+ i * xStep + 10; 						sFile.append("<line x1='" + tempX1 + "' y1='" + HistogramXy
					+ "' x2='" + (tempX1 + 10.0) + "' y2='"
					+ (HistogramXy - 10)
					+ "' stroke-width='1'  stroke='#333300'/>");
			sFile.append("\n");
		}
		
		int maxvalue = (int) valueMM;
		int valueX;		String fontsize = "";
		if (maxvalue > 10000) {
			valueX = 5;
			fontsize = "11px";
		} else {
			valueX = 15;
			fontsize = "13px";
		}
		for (int i = 0; i < 10; i++) {
			sFile.append("<text x='" + valueX + "' y='" + (45 + i * 40)
					+ "' fill='black' font-family='Verdana' font-size='"
					+ fontsize + "'>");
			sFile.append("\n");
			sFile.append((maxvalue / 10) * (10 - i));
			sFile.append("\n");
			sFile.append("</text>");
			sFile.append("\n");
		}
		
		sFile.append("<g style='filter:url(#MyFilter)'>");
		sFile.append("\n");
		for (int i = 0; i < pDataName.length; i++) {
						double tempX1 = i == 0 ? HistogramXSx + i * xStep : HistogramXSx
					+ i * xStep + 10;
			for (int j = 0; j < data1[i].length; j++) {
				double tempX2 = tempX1 + colWidthPre + j * colWidth; 				double colHeight = Math.ceil(Math.abs(data1[i][j]) * yStep);
				double tempY = 440 - colHeight;
				String[] colorHistogram; 				if (data1[i][j] < 0) {
					colorHistogram = colorNeg[0];
					sFile.append(paintHistogram(colWidth, colHeight, tempX2,
							tempY, colorHistogram, data1[i][j]));
				} else if (data1[i][j] > 0) {
					int n = j % color.length;
					colorHistogram = color[n];
					sFile.append(paintHistogram(colWidth, colHeight, tempX2,
							tempY, colorHistogram, data1[i][j]));
				}
			}
			
			int n = (int) xStep / 13;			int m = pDataName[i].length() % n == 0 ? pDataName[i].length() / n
					: (int) (pDataName[i].length() / n + 1);			int l = 0;			if (m > 1) {
				sFile
						.append("<text fill='blue' font-size='15px' font-family='STFangsong'>");
				for (int j = 0; j < m; j++) {
					for (int z = 0; z < n; z++) {
						l = j * n + z;
						if (l == pDataName[i].length()) {
							break;
						}
						sFile.append("<tspan x='" + (tempX1 + z * 15) + "' y='"
								+ (460 + j * 20) + "' >");
						sFile.append(pDataName[i].substring(l, l + 1));
						sFile.append("</tspan>");
					}
					if (l == pDataName[i].length()) {
						break;
					}
				}
				sFile.append("</text>");
				sFile.append("\n");
			} else {
				sFile
						.append("<text x='"
								+ (5 + tempX1)
								+ "' y='460' fill='blue' font-size='15px' font-family='STFangsong'>"
								+ pDataName[i] + "</text>");
				sFile.append("\n");
			}
		}
		sFile.append("</g>");
		sFile.append("\n");
		sFile.append("</svg>");
		return sFile.toString();
	}
	
	static String paintHistogram(double colWidth, double colHeight, double x,
			double y, String[] color, double datavalue) {
		StringBuffer sFile = new StringBuffer();
		double dOffset = (colWidth / 3) > 10.0 ? 10.0 : (colWidth / 3);		sFile.append("<rect width='" + colWidth + "' height='" + colHeight
				+ "' x='" + x + "' y='" + y + "' fill='" + color[0]
				+ "' onclick='showvalue(" + datavalue + ")'/>");
		sFile.append("\n");
		sFile.append("<polygon points='" + x + "," + y + " " + (x + dOffset)
				+ "," + (y - dOffset) + " " + (x + dOffset + colWidth) + ","
				+ (y - dOffset) + " " + (x + colWidth) + "," + y
				+ "' style='fill:" + color[1] + ";stroke:" + color[1]
				+ ";stroke-width:1;' onclick='showvalue(" + datavalue + ")'/>");
		sFile.append("\n");
		sFile.append("<polygon points='" + (x + dOffset + colWidth) + ","
				+ (y - dOffset) + " " + (x + colWidth) + "," + y + " "
				+ (x + colWidth) + "," + 440 + " " + (x + dOffset + colWidth)
				+ "," + (y - dOffset + colHeight) + "' style='fill:" + color[2]
				+ ";stroke:" + color[2]
				+ ";stroke-width:1;' onclick='showvalue(" + datavalue + ")'/>");
		return sFile.toString();
	}
	public static String getWsdd() {
		String dir = "D:\\Tomcat4.1.27\\logs\\localhost_admin_log.2004-10-22.txt";
		String fileContent = "";
		try {
			File wsdlFile = new File(dir);
						byte[] buffer = new byte[10240];
			DataInputStream input = new DataInputStream(
					new BufferedInputStream(new FileInputStream(wsdlFile)));
			input.read(buffer);
			input.close();
			fileContent = new String(buffer);
		} catch (FileNotFoundException e) {
			System.err.print("ļδҵ");
		} catch (IOException e) {
			System.err.println("ļ");
		}
		return (fileContent.trim());
	}
	public static int match(String matcher) {
		String a = getWsdd();
		System.out.println(a);
		Pattern p = Pattern.compile(matcher);
		int i = 0;
																																						i = p.split(a).length;
		return i - 1;
	}
	public static int match1() {
		BufferedReader in = null;
		Pattern pattern = Pattern.compile("2004-10-22");
		Matcher matcher = null;
		try {
			in = new BufferedReader(
					new FileReader(
							"D:\\Tomcat4.1.27\\logs\\localhost_admin_log.2004-10-22.txt"));
		} catch (FileNotFoundException e) {
						e.printStackTrace();
		}
		String s;
		int i = 0;
		try {
			while ((s = in.readLine()) != null) {
				matcher = pattern.matcher(s);
				if (matcher.find()) {
					i++;
					System.out.println(matcher.group());
				}
			}
		} catch (IOException e1) {
						e1.printStackTrace();
		}
		try {
			in.close();
		} catch (IOException e2) {
						e2.printStackTrace();
		}
		return i;
	}
	public static void main(String[] args) {
		long start = System.currentTimeMillis();
				int returnValue = test.match1();
		long end = System.currentTimeMillis();
		System.out.println("Tasks Time:" + (end - start)
				+ " milliseconds\nReturn Value:" + returnValue);
			}
}
