package org.act.manage.workflow.process;
import java.sql.Connection;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import org.act.manage.util.*;
import org.apache.struts.action.*;
import org.act.manage.workflow.WorkflowException;
import org.act.manage.workflow.meta.TypeInfo;
import org.act.manage.workflow.db.*;

public class ProcessTypesListAction
    extends Action
{
    public ActionForward execute(ActionMapping
                                 mapping,
                                 ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response) throws
        ServletException
    {
        try
        {
            ArrayList al = new ArrayList();
                        HashMap typeMap = null;
                        String serverType = (String) request.getSession().getAttribute(
			"ServerType");
            String server = (String) request.getSession().getAttribute("Server");
            ServerInfoMeta serverMeta=ServerInfo.getServerAddress(server,serverType);
            Connection connection = new 
				ConnectionDB().getConnection(serverMeta.getDBaddress(),
						serverMeta.getDBUser(),serverMeta.getDBPWD());
            typeMap=ProcessInfo.queryNumberInfo(connection);
            connection.close();
                        if (typeMap != null){
                                    
            Object[] key = typeMap.keySet().toArray();
            for (int i = 0; i < key.length; i++)
            {
                TypeInfo info = new TypeInfo();
                String typeName = key[i].toString();
                info.setName(key[i].toString());
                info.setCount(String.valueOf((Long)(typeMap.get(key[i]))));
                al.add(info);
            }
            }
                        request.setAttribute("WF_TypeInfoList", al);
        }
        catch (Exception ex)
        {
                        request.getSession().setAttribute("Util_FailBackPage", "/blank.jsp");
            String tmp = AdminResBundle.getMessage("wf.process.error.typeList");
            tmp += " " + ex.getMessage();
            request.getSession().setAttribute("Util_ErrorInfo", tmp);
            request.getSession().setAttribute("Util_ErrorDetail"
                                              , Utils.FormatExceptionToHtml(ex));
            return mapping.findForward("Failure");
        }
        return mapping.findForward("Forward");
    }
}
