
package org.act.manage.workflow.process;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Vector;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.ConnectionDB;
import org.act.manage.util.ServerInfo;
import org.act.manage.util.ServerInfoMeta;
import org.act.manage.util.Utils;
import org.act.manage.workflow.WorkflowException;
import org.act.manage.workflow.db.InferResourceInfo;
import org.act.manage.workflow.db.SuperInfo;
import org.act.manage.workflow.meta.TransactionInfoMeta;
import org.act.manage.wsruntime.meta.InferiorInfoMeta;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class TransactionInfoAction    extends Action
{
	  private boolean needUpdateTree = false;
	  public ActionForward execute(ActionMapping
	                               mapping,
	                               ActionForm form,
	                               HttpServletRequest request,
	                               HttpServletResponse response) throws
	      ServletException
	  {
	  	 
		  
		    String txID = "";
		    try
		    {
		      
		      ArrayList al = new ArrayList();
		      		      		      		      
		      txID=request.getParameter("txID");
		      		      		      String serverType = (String) request.getSession().getAttribute(
				"ServerType");
	            String server = (String) request.getSession().getAttribute("Server");
	            ServerInfoMeta serverMeta=ServerInfo.getServerAddress(server,serverType);
	            Connection connection = new 
					ConnectionDB().getConnection(serverMeta.getDBaddress(),
							serverMeta.getDBUser(),serverMeta.getDBPWD());
		      Vector transaction;
		      transaction = SuperInfo.queryInfo(connection,txID);
		      if (transaction == null)
		      {
		        		        throw new WorkflowException(AdminResBundle.getMessage(
		            "util.error.nullRes", "Business Process ID"));
		      }
		      		      TransactionInfoMeta info=new TransactionInfoMeta();
		      
		      info.setTxID(transaction.elementAt(0).toString());
		      info.setBeginTime(this.transferTime(transaction.elementAt(1).toString()));
		      if (null == transaction.elementAt(2) || transaction.elementAt(2).toString().equals("")
		          || transaction.elementAt(2).toString().equals("0"))		        info.setEndTime(" ");
		      else
		        info.setEndTime(this.transferTime(transaction.elementAt(2).toString()));
		      
		      if (null == transaction.elementAt(3) || transaction.elementAt(3).toString().equals("")
			          || transaction.elementAt(3).toString().equals("0"))
			        info.setPreparetime_b(" ");
			      else
			        info.setPreparetime_b(this.transferTime(transaction.elementAt(3).toString()));
		      
		      if (null == transaction.elementAt(4) || transaction.elementAt(4).toString().equals("")
			          || transaction.elementAt(4).toString().equals("0"))
			        info.setPrepare_time_e(" ");
			      else
			        info.setPrepare_time_e(this.transferTime(transaction.elementAt(4).toString()));
		      
		      if (null == transaction.elementAt(5) || transaction.elementAt(5).toString().equals("")
			          || transaction.elementAt(5).toString().equals("0"))
			        info.setConfirmtime_b(" ");
			      else
			        info.setConfirmtime_b(this.transferTime(transaction.elementAt(5).toString()));
		      if (null == transaction.elementAt(6) || transaction.elementAt(6).toString().equals("")
			          || transaction.elementAt(6).toString().equals("0"))
			        info.setConfirmtime_e(" ");
			      else
			        info.setConfirmtime_e(this.transferTime(transaction.elementAt(6).toString()));
		      
		      if (null == transaction.elementAt(7)|| transaction.elementAt(7).toString().equals("")
			          || transaction.elementAt(7).toString().equals("0"))
			        info.setCanceltime_b(" ");
			      else
			        info.setCanceltime_b(this.transferTime(transaction.elementAt(7).toString()));
		      
		      if (null == transaction.elementAt(8) || transaction.elementAt(8).toString().equals("")
			          || transaction.elementAt(8).toString().equals("0"))
			        info.setCanceltime_e(" ");
			      else
			        info.setCanceltime_e(this.transferTime(transaction.elementAt(8).toString()));
		      
		      
			 info.setResult(transaction.elementAt(9).toString());
			 
		      info.setSuperiorAddress(transaction.elementAt(11).toString());
		      info.setTransactionStatus(makeStatusString(transaction,10));
		      		      al.add(info);
		      		      request.getSession().setAttribute("WF_TransactionList", al);
		      		      ArrayList alInferior = new ArrayList();
		      		      Vector inferior;
		      Connection connection1 = new 
				ConnectionDB().getConnection(serverMeta.getDBaddress(),
						serverMeta.getDBUser(),serverMeta.getDBPWD());
		      inferior = InferResourceInfo.queryInfo(connection1,txID);
		      if (inferior == null)
		      {
		        		        throw new WorkflowException(AdminResBundle.getMessage(
		            "util.error.nullRes", "Transaction ID"));
		      }
		      		      		      Vector oneInfo;
		      for (int i = 0; i < inferior.size(); i++)
		      {
		        oneInfo = (Vector)inferior.get(i);
		        InferiorInfoMeta infoI = new InferiorInfoMeta();
		        
		        infoI.setInferiorID(oneInfo.elementAt(0).toString());
		        		        infoI.setInferiorStatus(makeStatusString(oneInfo,1));
		        if (null == transaction.elementAt(2) || transaction.elementAt(2).toString().equals("")
				          || transaction.elementAt(2).toString().equals("0"))
		        	infoI.setPreparetime_b(" ");
				      else
				      	infoI.setPreparetime_b(this.transferTime(transaction.elementAt(2).toString()));
			      
			      if (null == transaction.elementAt(3) || transaction.elementAt(3).toString().equals("")
				          || transaction.elementAt(3).toString().equals("0"))
			      	infoI.setPreparetime_e(" ");
				      else
				      	infoI.setPreparetime_e(this.transferTime(transaction.elementAt(3).toString()));
			      
			      if (null == transaction.elementAt(4) || transaction.elementAt(4).toString().equals("")
				          || transaction.elementAt(4).toString().equals("0"))
			      	infoI.setConfirmtime_b(" ");
				      else
				      	infoI.setConfirmtime_b(this.transferTime(transaction.elementAt(4).toString()));
			      if (null == transaction.elementAt(5) || transaction.elementAt(5).toString().equals("")
				          || transaction.elementAt(5).toString().equals("0"))
			      	infoI.setConfirmtime_e(" ");
				      else
				      	infoI.setConfirmtime_e(this.transferTime(transaction.elementAt(5).toString()));
			      
			      if (null == transaction.elementAt(6) || transaction.elementAt(6).toString().equals("")
				          || transaction.elementAt(6).toString().equals("0"))
			      	infoI.setCanceltime_b(" ");
				      else
				      	infoI.setCanceltime_b(this.transferTime(transaction.elementAt(6).toString()));
			      
			      if (null == transaction.elementAt(7) || transaction.elementAt(7).toString().equals("")
				          || transaction.elementAt(7).toString().equals("0"))
			      	infoI.setCanceltime_e(" ");
				      else
				      	infoI.setCanceltime_e(this.transferTime(transaction.elementAt(7).toString()));
			      
		        alInferior.add(infoI);
		      }
		      		      request.getSession().setAttribute("WF_InferiorList", alInferior);
		      setHistorySession(request, txID);
		    }
		    catch (Exception ex)
		    {
		      		      request.getSession().setAttribute("Util_FailBackPage", "/blank.jsp");
		      String tmp = AdminResBundle.getMessage("wf.process.error.tranList"
		                                             , txID);
		      tmp += " " + ex.getMessage();
		      request.getSession().setAttribute("Util_ErrorInfo", tmp);
		      request.getSession().setAttribute("Util_ErrorDetail"
		                                        , Utils.FormatExceptionToHtml(ex));
		      return mapping.findForward("Failure");
		    }
		    if (needUpdateTree)
		    {
		      needUpdateTree = false;
		      request.getSession().setAttribute("Util_AfterUpdateTree",
		                                        "/workflow/process/processTransaction.jsp");
		      return mapping.findForward("UpdateTree");
		    }
		    else
		      return mapping.findForward("Forward");
		  }
		  private void setHistorySession(HttpServletRequest request, String ID)
		  {
		    String hisTxID = (String)request.getSession().getAttribute(
		        "WF_History_TransactionID");
		    if (hisTxID == null || !hisTxID.equals(ID))
		    {
		      request.getSession().setAttribute("WF_History_TransactionID", ID);
		      		      		      needUpdateTree = true;
		    }
		  }
		  private String makeStatusString(Vector oneInfo,int n)
		  {
		    String status = oneInfo.elementAt(n).toString();
		    if (status.equalsIgnoreCase("Begun"))
		      return AdminResBundle.getMessage("wf.process.table.status.transaction.Begun");
		    else if (status.equalsIgnoreCase("Confirmed"))
		      return AdminResBundle.getMessage("wf.process.table.status.transaction.Confirmed");
		    else if (status.equalsIgnoreCase("Cancelled"))
		      return AdminResBundle.getMessage(
		          "wf.process.table.status.transaction.Canceled");
		    else if (status.equalsIgnoreCase("true"))
		      return AdminResBundle.getMessage(
		          "wf.process.table.status.transaction.true");
		    else if (status.equalsIgnoreCase("false"))
		      return AdminResBundle.getMessage("wf.process.table.status.transaction.false");
		    else if (status.equalsIgnoreCase("Active"))
		      return AdminResBundle.getMessage(
		          "wf.process.table.status.inferior.Active");
		    else if (status.equalsIgnoreCase(""))
		      return " ";
		    else return status;
		  }
		  		  private static String transferTime(String timeOrg)
		  {
		    long a = Long.parseLong(timeOrg);
		    Date datea = new Date();
		    datea.setTime(a);
		    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
		    String timea = sdf.format(datea).toString();
		    return timea;
		  }
	}
