
package org.act.manage.wsruntime.config;
import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.Utils;
import org.act.manage.workflow.WorkflowException;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class ConfigDefaultAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		String backUrl = "/blank.jsp";
		try {
			backUrl = "/workflow/config/configEdit.do";
						
								}
		catch (Exception ex) {
						request.getSession().setAttribute("Util_FailBackPage", backUrl);
			String tmp = AdminResBundle.getMessage("wf.config.error.default");
			tmp += " " + ex.getMessage();
			request.getSession().setAttribute("Util_ErrorInfo", tmp);
			request.getSession().setAttribute("Util_ErrorDetail",
					Utils.FormatExceptionToHtml(ex));
			return mapping.findForward("Failure");
		}
		return mapping.findForward("Back");
	}
	private String loadFromFile(String fileName) {
		String fileContent = "";
		File process = null;
		process = new File(fileName);
		try {
			byte[] buffer = new byte[4096];
			DataInputStream input = new DataInputStream(
					new BufferedInputStream(new FileInputStream(process)));
			input.read(buffer);
			input.close();
			fileContent = new String(buffer);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return fileContent;
	}
}
