
package org.act.manage.wsruntime.service;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.CallServer;
import org.act.manage.util.ServerInfo;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class getWsdlAction extends Action {
    public ActionForward execute(ActionMapping mapping,
            ActionForm form,
            HttpServletRequest request,
            HttpServletResponse response)
    throws ServletException
	{
				String serviceName = request.getParameter("service");
		
		
		try {
			String serverType=(String)request.getSession().getAttribute("ServerType");
			String server=(String)request.getSession().getAttribute("Server");
			CallServer callServer=new CallServer
			(ServerInfo.getServerAddress(server,serverType).getAddress());
		String result="";
		try{
			result=callServer.testgetWsdl(serviceName);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		
		request.setAttribute("wsdl",result);
		} 
		catch(Throwable e) {
		request.getSession().setAttribute("Util_FailBackPage", "/blank.jsp");
		e.printStackTrace();
		return mapping.findForward("Failure");
		}
		
				
		request.setAttribute("serviceName", serviceName);
		
				return mapping.findForward("ServiceWSDL");
	}
    
    
    private static String normalize(String s) {
        StringBuffer str = new StringBuffer();
        int len = (s != null) ? s.length() : 0;
        for (int i = 0; i < len; i++) {
            char ch = s.charAt(i);
            switch (ch) {
            case ' ': {
                str.append("&nbsp;");
                break;
            }
            case '\n': {
                str.append("<br>");
                break;
            }
            default: {
                str.append(ch);
            }
            }
        }
        return (str.toString());
    } }
