<%@taglib uri="/WEB-INF/struts-nested.tld" prefix="nested"%>
<%@taglib uri="/WEB-INF/struts-logic.tld" prefix="logic"%>
<%@taglib uri="/WEB-INF/struts-bean.tld" prefix="bean"%>
<%@taglib uri="/WEB-INF/struts-html.tld" prefix="html"%>
<%@taglib uri="/WEB-INF/controls.tld" prefix="controls"%>
<%@page contentType="text/html; charset=utf-8"%>
<%@page import="org.act.manage.util.Utils" %>
<!--
  显示某种类型流程实例列表
  传?参?:
  WF_ProcessList (request) 流程实例链表
  WF_History_TypeName (session) 流程类型?
-->

<html:html>
<head>
  <link href="../../Admin.css" rel="stylesheet" type="text/css">
<title>
  <bean:message key="wf.process.title.process"/>
</title>
</head>

<controls:body titleKey="wf.process.title.process">
  <jsp:include page="viewChain.jsp" flush="true"/>
  <br>
  <br>
  <h3 align="center"></h3>


 <controls:ACTTable width="100%" align="center">
          <controls:tr styleClass="table_header" align="center">
            <td width=30%>
              <bean:message key="wf.process.treeBuilder.types"/>
            </td>
            <td width=30%>
              <bean:message key="wf.process.table.process.id"/>
            </td>
            <td width=18%>
              <bean:message key="wf.process.table.beginTime"/>
            </td>

            <td width=20%>
              <bean:message key="wf.process.table.process.status"/>
            </td>
            <td width=25%>
              <bean:message key="util.op"/>
            </td>
          </controls:tr>

          <bean:define id="tmpOffset" name="WF_Page_ProcessItem"/>
          <logic:iterate id="ListItem" name="WF_ProcessList" length="Util_PageSize" offset="<%=tmpOffset.toString()%>">
            <controls:tr styleClass="table_content">
              <td align="center">
                <bean:write name="ListItem" property="type"/>
              </td>
              <td align="center">
                <bean:write name="ListItem" property="processID"/>
              </td>
              <td align="center">
                <bean:write name="ListItem" property="beginTime"/>
              </td>

              <td align="center">
                <bean:write name="ListItem" property="status"/>
              </td>
              <td  align="center">
                <html:link page="/workflow/instance/ShowActivity.do" paramId="InstanceID" paramName="ListItem" paramProperty="processID">
                  <html:img src="../../images/Next.gif" border="0" align="top"/><bean:message key="util.op.list"/>
                </html:link>
				<html:link page="/workflow/instance/activityGraph.do" paramId="ID" paramName="ListItem" paramProperty="processID">
                  &nbsp;<html:img src="../../images/Flow.gif" border="0" align="top" altKey="wf.process.table.process.graph"/>
                </html:link>
              </td>
            </controls:tr>
          </logic:iterate>

  </controls:ACTTable>

  </controls:body>
</html:html>
