<%@taglib uri="/WEB-INF/struts-nested.tld" prefix="nested"%>
<%@taglib uri="/WEB-INF/struts-logic.tld" prefix="logic"%>
<%@taglib uri="/WEB-INF/struts-bean.tld" prefix="bean"%>
<%@taglib uri="/WEB-INF/struts-html.tld" prefix="html"%>
<%@taglib uri="/WEB-INF/controls.tld" prefix="controls"%>
<%@page contentType="text/html; charset=utf-8"%>
<!--
  显示某业务流程的活动流程列表
  传?参?:
  WF_ActivityList (request) 流程实例链表
  WF_History_BusinessName (session) 业务流程?
  WF_History_Process (session) 流程ID
  WF_History_TypeName (session) 流程类型?
-->

<html:html>
<head>
  <link href="../../Admin.css" rel="stylesheet" type="text/css">
<title>
  <bean:message key="wf.process.title.activity"/>
</title>
</head>

<controls:body titleKey="wf.process.title.activity">
  <jsp:include page="viewChain.jsp" flush="true"/>
  <br>
  <br>
  <h3 align="center"><bean:write name="WF_History_Process"/></h3>
  <bean:define id="tmpBtnName">
    <bean:message key="util.refresh"/>
  </bean:define>
  <bean:define id="tmpUrl">
    activityList.do?ID=<bean:write name="WF_History_Process"/>
  </bean:define>
  <center>
    <input type="button"  class="input_button" value="<%=tmpBtnName%>" style="width:100px" onclick="window.location='<%=tmpUrl%>'">
  </center>

  <controls:ACTTable width="100%" align="center">
          <controls:tr styleClass="table_header" align="center">
            <td width=25%>
              <bean:message key="wf.process.table.activity.name"/>
            </td>
            <td width=20%>
              <bean:message key="wf.process.table.activity.type"/>
            </td>
            <td width=20%>
              <bean:message key="wf.process.table.beginTime"/>
            </td>
            <td width=20%>
              <bean:message key="wf.process.table.endTime"/>
            </td>
            <td width=15%>
              <bean:message key="wf.process.table.activity.status"/>
            </td>
            
          </controls:tr>

          <logic:iterate id="ListItem" name="WF_ActivityList">
            <controls:tr styleClass="table_content">
              <td align="center">
                <bean:write name="ListItem" property="name"/>&nbsp;
              </td>
              <td align="center">
                <bean:write name="ListItem" property="type"/>&nbsp;
              </td>
              <td  align="center">
                <bean:write name="ListItem" property="beginTime"/>&nbsp;
              </td>
              <td align="center">
                <bean:write name="ListItem" property="endTime"/>&nbsp;
              </td>
              <td  align="center">
                <bean:write name="ListItem" property="status"/>&nbsp;
              </td>

              

            </controls:tr>
          </logic:iterate>

      
  </controls:ACTTable>
  </controls:body>
</html:html>

