<!-- Standard Struts Entries -->

<%@ page language="java" contentType="text/html;charset=utf-8" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/controls.tld" prefix="controls"%>

<html:html locale="true">

  <%@ include file="../header.jsp" %>

  <controls:body>

   <%-- Cause our tree control to refresh itself --%>
    <script language="JavaScript">
      <!--
        parent.tree.location='../../setUpTree.do';
      -->
    </script>

    <%-- display warnings if any --%>
    <logic:present name="warning">
            <bean:message key="warning.header"/>
            <bean:message key='<%= (String) request.getAttribute("warning") %>'/>
            <br>
    </logic:present>

    <center><h2>
      <bean:message key="undeploy.success"/>
    </h2></center>

    <%@ include file="../footer.jsp" %>

  </controls:body>

</html:html>
