package org.act.manage.controls;
import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import javax.servlet.http.HttpSession;
import java.util.Locale;
import org.apache.struts.util.MessageResources;
import org.apache.struts.Globals;

public class ACTBodyTag
extends BodyTagSupport
{
public static final String mContentIcon =
    "/ACTManager/images/content_icon.gif";
private String title = "";
private String titleKey = "";
private String background = "/ACTManager/images/";
private String width = "100%";
private String height = "100%";

public int doStartTag() throws JspException
{
    JspWriter out = pageContext.getOut();
    try
    {
        if (title.equals(""))
        {
            MessageResources resources = (MessageResources)pageContext.
                                         getServletContext().getAttribute(
                                             Globals.
                                             MESSAGES_KEY);
            HttpSession session = pageContext.getSession();
            Locale locale = (Locale)session.getAttribute(Globals.LOCALE_KEY);
            title = resources.getMessage(locale, titleKey);
        }
        if (title == null)title = "";
        out.print("<body leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\" background=\"" + background
            + "content_back.jpg\" style=\"background-attachment: fixed;background-repeat:no-repeat;background-position: right bottom\">\n");
        out.print("<table width=\"100%\" height=\"27\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n");
        out.print("<tr>\n");
        out.print("<td background=\"" + background
            + "content_backbar.gif\"> &nbsp;&nbsp;&nbsp;&nbsp;<img src=\""
                  + mContentIcon
            + "\" width=\"27\" height=\"27\" align=\"absmiddle\"><b><font size=\"2\">"
                  + title + "</font></td>\n");
        out.print("</tr>\n");
        out.print("</table>\n");
        out.print("<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n");
        out.print("<tr>\n");
        out.print("<td valign=\"top\" height=\"400\">\n");
    }
    catch (IOException ex)
    {
        ex.printStackTrace();
    }
    return (EVAL_BODY_INCLUDE);
}

public int doEndTag() throws JspException
{
        JspWriter out = pageContext.getOut();
    try
    {
        out.print("</td>\n");
        out.print("</tr>\n");
        out.print("</table>\n");
        out.print("</body>");
    }
    catch (IOException ex)
    {
        ex.printStackTrace();
    }
    return (EVAL_PAGE);
}
public void setTitle(String title)
{
    this.title = title;
}
public void setTitleKey(String titleKey)
{
    this.titleKey = titleKey;
}
public void setBackground(String background)
{
    this.background = background;
}
public void setWidth(String width)
{
    this.width = width;
}
public void setHeight(String height)
{
    this.height = height;
}
public String getTitle()
{
    return title;
}
public String getTitleKey()
{
    return titleKey;
}
public String getBackground()
{
    return background;
}
public String getWidth()
{
    return width;
}
public String getHeight()
{
    return height;
}
}
