
package org.act.manage.soap;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.xml.namespace.QName;
import org.act.manage.util.CallServer;
import org.act.manage.util.CallWfEngine;
import org.act.manage.util.ServerInfo;
import org.act.soap.util.TMConstants;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class soapInfoAction extends Action {
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		
				HttpSession session = request.getSession();
		String backPage = (String) session.getAttribute("Util_SucBackUrl");
		String serverType = (String) request.getSession().getAttribute(
				"ServerType");
		String server = (String) request.getSession().getAttribute("Server");
		CallServer callServer = new CallServer(ServerInfo.getServerAddress(
				server, serverType).getAddress());
		
		
		String sendRMCacheNum=" ";
		String sendRMReplyCacheNum=" ";
		String receiveRMReplyCacheNum=" ";
		String receiveRMCacheNum=" ";
		
		String uri = ServerInfo.getServerAddress(server, serverType)
				.getAddress();
		if (serverType.equals("WSRuntime")) {
			try {
				String result=(String) CallServer
				.invoke("getRMPCacheNum", uri, TMConstants.XSD_STRING,
						new QName[] {}, new Object[] {});
				String num[]=result.split("#");
				sendRMCacheNum=num[0];
				sendRMReplyCacheNum=num[1];
				receiveRMReplyCacheNum=num[2];
				receiveRMCacheNum=num[3];
				
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else if (serverType.equals("WorkflowEngine")) {
			try {
				String result=(String) CallWfEngine
				.invoke("getRMPCacheNum", uri, TMConstants.XSD_STRING,
						new QName[] {}, new Object[] {});
				String num[]=result.split("#");
				sendRMCacheNum=num[0];
				sendRMReplyCacheNum=num[1];
				receiveRMReplyCacheNum=num[2];
				receiveRMCacheNum=num[3];
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else {
			return mapping.findForward("Fail");
		}
		request.setAttribute("sendRMCacheNum", sendRMCacheNum);
		request.setAttribute("sendRMReplyCacheNum", sendRMReplyCacheNum);
		request.setAttribute("receiveRMReplyCacheNum", receiveRMReplyCacheNum);
		request.setAttribute("receiveRMCacheNum", receiveRMCacheNum);
		return mapping.findForward("Forward");
	}
}
