
package org.act.manage.threadpool;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.xml.namespace.QName;
import org.act.manage.util.CallServer;
import org.act.manage.util.CallWfEngine;
import org.act.manage.util.ServerInfo;
import org.act.soap.util.TMConstants;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class ThreadPoolInfoAction extends Action {
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		
		String name = (String) request.getParameter("Name");
		HttpSession session = request.getSession();
		session.setAttribute("Threadpoolname", name);
		String backPage = (String) session.getAttribute("Util_SucBackUrl");
		String serverType = (String) request.getSession().getAttribute(
				"ServerType");
		String server = (String) request.getSession().getAttribute("Server");
		String TPCurrentTreadBusy = "";
		String TPCurrentTreadCount = "";
		String TPMaxSpareThread = "";
		String TPMaxThread = "";
		String TPMinSpareThread = "";
		String uri = ServerInfo.getServerAddress(server, serverType)
				.getAddress();
		if (serverType.equals("WSRuntime")) {
			try {
				TPCurrentTreadBusy = (String) CallServer.invoke("getTPCurrentTreadBusy", uri,
						TMConstants.XSD_STRING,
						new QName[] { javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name });
				TPCurrentTreadCount = (String) CallServer.invoke("getTPCurrentTreadCount", uri,
						TMConstants.XSD_STRING,
						new QName[] { javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name });
				TPMaxSpareThread = (String) CallServer.invoke("getTPMaxSpareThread", uri,
						TMConstants.XSD_STRING,
						new QName[] { javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name });
				TPMaxThread = (String) CallServer.invoke("getTPMaxThread", uri,
						TMConstants.XSD_STRING,
						new QName[] { javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name });
				TPMinSpareThread = (String) CallServer.invoke("getTPMinSpareThread", uri,
						TMConstants.XSD_STRING,
						new QName[] { javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name });
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else if (serverType.equals("WorkflowEngine")) {
			try {
				TPCurrentTreadBusy = (String) CallWfEngine.invoke("getTPCurrentTreadBusy", uri,
						TMConstants.XSD_STRING,
						new QName[] { javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name });
				TPCurrentTreadCount = (String) CallWfEngine.invoke("getTPCurrentTreadCount", uri,
						TMConstants.XSD_STRING,
						new QName[] { javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name });
				TPMaxSpareThread = (String) CallWfEngine.invoke("getTPMaxSpareThread", uri,
						TMConstants.XSD_STRING,
						new QName[] { javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name });
				TPMaxThread = (String) CallWfEngine.invoke("getTPMaxThread", uri,
						TMConstants.XSD_STRING,
						new QName[] { javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name });
				TPMinSpareThread = (String) CallWfEngine.invoke("getTPMinSpareThread", uri,
						TMConstants.XSD_STRING,
						new QName[] { javax.xml.rpc.encoding.XMLType.XSD_STRING },
						new Object[] { name });
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else {
			return mapping.findForward("Fail");
		}
		request.setAttribute("Name", name);
		request.setAttribute("TPCurrentTreadBusy", TPCurrentTreadBusy);
		request.setAttribute("TPCurrentTreadCount", TPCurrentTreadCount);
		request.setAttribute("TPMaxSpareThread", TPMaxSpareThread);
		request.setAttribute("TPMaxThread", TPMaxThread);
		request.setAttribute("TPMinSpareThread", TPMinSpareThread);
		return mapping.findForward("Forward");
	}
}
