
package org.act.manage.tree;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.act.manage.RBACManager;
import org.act.manage.controls.TreeControl;
import org.act.manage.controls.TreeControlNode;
import org.act.manage.util.CallServer;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class SwitchTreeAction extends Action {
	private boolean needUpdateTree = false;
	
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException 
	{
	
	 
		
		HttpSession session = request.getSession();
						RBACManager rbac = (RBACManager)session.getAttribute(
        "ACTRBAC");
		if(rbac == null)
			return (mapping.findForward("Blank"));
		String server=(String)request.getParameter("ServerName");
		rbac.changeTreeBuilders(server);
		ArrayList serverList=new ArrayList();
		serverList=rbac.getMUserServerList();
        for(int i=0;i<serverList.size();i++)
        {
        	if (((String)(serverList.get(i))).equals(server))
        	{
        		serverList.remove(i);
        		break;
        	}
        	
        }
        request.getSession().setAttribute("Server", server);
        
        request.getSession().setAttribute("ServerList", serverList);
        String serverType=rbac.getMServerType();
        request.getSession().setAttribute("ServerType", serverType);
		
		needUpdateTree=true;
		if (needUpdateTree)
        {
            needUpdateTree = false;
            request.getSession().setAttribute("Util_AfterUpdateTree",
                                              "banner.jsp");
            return mapping.findForward("UpdateTree");
        }
        else
            return mapping.findForward("Forward");
	}
}
