
package org.act.manage.user;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FilterOutputStream;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.Utils;
import org.act.manage.wsruntime.config.ConfigForm;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class ConfigSaveAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		String backUrl = "/blank.jsp";
		try {
						UserConfigForm configForm = (UserConfigForm) form;
			String confFile = configForm.getText();
			File userConfigFile = null;
			userConfigFile = new File(Utils.mUserConfigFile);
						
			FilterOutputStream output = new FilterOutputStream(
					new FileOutputStream(Utils.mUserConfigFile));
			output.write(confFile.getBytes());
			output.close();
			
		} catch (Exception ex) {
						request.getSession().setAttribute("Util_FailBackPage", backUrl);
			String tmp = AdminResBundle.getMessage("wf.config.error.edit");
			tmp += " " + ex.getMessage();
			request.getSession().setAttribute("Util_ErrorInfo", tmp);
			request.getSession().setAttribute("Util_ErrorDetail",
					Utils.FormatExceptionToHtml(ex));
			return mapping.findForward("Failure");
		}
		request.getSession().setAttribute("Util_SucInfo",
				AdminResBundle.getMessage("wf.config.success.Save"));
		request.getSession().setAttribute("Util_SucBackUrl",
				"/user/configEdit.do");
				return mapping.findForward("Success");
	}
}
