
package org.act.manage.user;
import java.util.Locale;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.act.manage.controls.TreeBuilder;
import org.act.manage.controls.TreeControl;
import org.act.manage.controls.TreeControlNode;
import org.act.manage.util.Utils;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.util.MessageResources;

public class PersonTreeBuilder   implements TreeBuilder
{
    
    public void buildTree(TreeControl treeControl, ActionServlet servlet
                          , HttpServletRequest request)
    {
        MessageResources resources = (MessageResources)servlet.
                                     getServletContext().getAttribute(Globals.
            MESSAGES_KEY);
        HttpSession session = request.getSession();
        Locale locale = (Locale)session.getAttribute(Globals.LOCALE_KEY);
        TreeControlNode personNode = new TreeControlNode
                                  ("Person_edit",
                                        "Person.gif",
		                                   resources.getMessage(locale
		            , "user.treebuilder.personedit"),
		                                   "personEdit.do",
		                                   "content",
		                                   Utils.checkTreeNodeState("Person_edit", false),
		                                   "Person_edit");
        treeControl.getRoot().addChild(personNode);
    }
}
