
package org.act.manage.user;
import java.util.ArrayList;
import java.util.Vector;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.ServerInfoMeta;
import org.act.manage.util.Utils;
import org.act.manage.util.XMLConfigUtil;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class UserListAction    extends Action
{
    public ActionForward execute(ActionMapping mapping
                                 , ActionForm actionForm
                                 , HttpServletRequest request
                                 , HttpServletResponse servletResponse)
    {
        try
        {
                        String filePath = Utils.mUserConfigFile;
            Document doc = XMLConfigUtil.loadDocumentFromFile(filePath);
                        Vector v = null;
            v = XMLConfigUtil.getElement(doc, null, "user", null);
            int i = 0;
            i = v.size();
            Element ele = null;
            ArrayList list = new ArrayList();
            
            String name;
            boolean top;
            for(int j=0;j<i;j++){
                                ele = (Element) v.elementAt(j);
                name = XMLConfigUtil.getTextByPath(doc, ele, "username", null, null);
                                ArrayList xlinker = new ArrayList();
                ArrayList workflow = new ArrayList();
                                Vector runtimeEles = XMLConfigUtil.getElement(doc, ele, "purview/WSRumtime", null);
                Element runtimeEle = null;
                for (int k = 0; k < runtimeEles.size(); k++)
                {
                	ServerInfoMeta sim=new ServerInfoMeta();
                	runtimeEle = (Element)runtimeEles.get(k);
                	String type = XMLConfigUtil.getTextByPath(doc, runtimeEle
    	                , "pv", null, null);
    	            
    	            String mserver=XMLConfigUtil.getTextByPath(doc, runtimeEle
    		                , "name", null, null);
    	           sim.setName(mserver);
    	           sim.setPurview(makeRightString(type));
    	           xlinker.add(sim);
                }
                                Vector wfEles = XMLConfigUtil.getElement(doc, ele, "purview/Workflow", null);
                Element wf = null;
                for (int k = 0; k < wfEles.size(); k++)
                {
                	ServerInfoMeta sim=new ServerInfoMeta();
                	wf = (Element)wfEles.get(k);
                	String type = XMLConfigUtil.getTextByPath(doc, wf
    	                , "pv", null, null);
    	            String mserver=XMLConfigUtil.getTextByPath(doc, wf
    		                , "name", null, null);
    	            sim.setName(mserver);
     	           sim.setPurview(makeRightString(type));
     	           workflow.add(sim);
                }
                
                top = new Boolean(XMLConfigUtil.getTextByPath(doc, ele, "purview/top", null, null)).booleanValue();
                                UserInfoForm userInfo = new UserInfoForm();
                userInfo.setUsername(name);
                
                userInfo.setTop(top);
                userInfo.setWorkflow(workflow);                userInfo.setXlinker(xlinker);                list.add(userInfo);
            }
                        request.getSession().setAttribute("list", list);
        }
        catch (Exception ex)
        {
                        String backUrl = "blank.jsp";
            request.getSession().setAttribute("Util_FailBackPage", backUrl);
            String tmp = AdminResBundle.getMessage("user.error.userlist");
            tmp += " "+ex.getMessage();
            request.getSession().setAttribute("Util_ErrorInfo", tmp);
            request.getSession().setAttribute("Util_ErrorDetail"
                                              , Utils.FormatExceptionToHtml(ex));
            return mapping.findForward("Failure");
        }
        return mapping.findForward("Forward");
    }
        private static String makeRightString(String right)
    {
      if (right==null) return " ";
      else if (right.equalsIgnoreCase("view"))
        return AdminResBundle.getMessage("user.util.purview.view");
      else if (right.equalsIgnoreCase("view/modify"))
        return AdminResBundle.getMessage(
            "user.util.purview.modify");
      else if(right.equalsIgnoreCase("view/modify/delete"))
        return AdminResBundle.getMessage("user.util.purview.delete");
      else if(right.equalsIgnoreCase("true"))
        return AdminResBundle.getMessage("user.util.top.true");
      else if(right.equalsIgnoreCase("false"))
        return AdminResBundle.getMessage("user.util.top.false");
      else return(" ");
    }
    }
