
package org.act.manage.user;
import java.util.ArrayList;
import java.util.Vector;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.ServerInfoMeta;
import org.act.manage.util.Utils;
import org.act.manage.util.XMLConfigUtil;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class UserSaveAction    extends Action
{
    public ActionForward execute(ActionMapping mapping
                                 , ActionForm actionForm
                                 , HttpServletRequest request
                                 , HttpServletResponse servletResponse)
    {
                String op = (String) request.getSession().getAttribute("op");
                UserInfoForm form = (UserInfoForm)actionForm;
        String username = form.getUsername();
        String remark = form.getRemark();
        String email = form.getEmail();
        ArrayList xlinker = form.getXlinker();
        ArrayList workflow = form.getWorkflow();
        boolean top = form.isTop();
        try
        {
                        String filePath = Utils.mUserConfigFile;
            Document doc = XMLConfigUtil.loadDocumentFromFile(filePath);
                        Vector v = XMLConfigUtil.getElement(doc, null, "user", null);
            int i = v.size();
            Element ele = null;
            String name;
            boolean exist = false;
            for (int j = 0; j <= i - 1; j++)
            {
                ele = (Element)v.elementAt(j);
                name = XMLConfigUtil.getTextByPath(doc, ele, "username", null, null);
                if (username.equals(name))
                {                     exist = true;
                    break;
                }
            }
            if (op.equals("modify")){                 if (exist)
                {                     XMLConfigUtil.setTextByPath(doc, ele, "username", null, null
                                                , username);
                    String password1 = request.getParameter("password1");
                    if (!password1.equals(""))
                    {                         XMLConfigUtil.setTextByPath(doc, ele, "password", null, null
                            , password1);
                    }
                    XMLConfigUtil.setTextByPath(doc, ele, "remark", null, null
                                                , remark);
                    XMLConfigUtil.setTextByPath(doc, ele, "email", null, null
                                                , email);
                    if(xlinker==null)
                    {
                    	for(int k=0 ;k<xlinker.size();k++)
                    	{
                    		XMLConfigUtil.setTextByPath(doc, ele, "purview/WSRumtime/name", null, null
                    				 ,((ServerInfoMeta)(xlinker.get(k))).getName());
                        	XMLConfigUtil.setTextByPath(doc, ele, "purview/WSRumtime/pv", null, null
                                    ,((ServerInfoMeta)(xlinker.get(k))).getPurview());
                    	}
                                                       
                    }
                    else
                    {
                    	XMLConfigUtil.setTextByPath(doc, ele, "purview/Xlinker", null, null
                                , "");
                    }
                    if(workflow==null)
                    {
                    	for(int k=0 ;k<workflow.size();k++)
                    	{
                    		XMLConfigUtil.setTextByPath(doc, ele, "purview/WSRumtime/name", null, null
                    				 ,((ServerInfoMeta)(workflow.get(k))).getName());
                        	XMLConfigUtil.setTextByPath(doc, ele, "purview/WSRumtime/pv", null, null
                                    ,((ServerInfoMeta)(workflow.get(k))).getPurview());
                    	}
                                                       
                    }
                    else
                    {
                    	XMLConfigUtil.setTextByPath(doc, ele, "purview/Xlinker", null, null
                                , "");
                    }
                    
                    
                    XMLConfigUtil.setTextByPath(doc, ele, "purview/top", null, null
                                                , new Boolean(top).toString());
                    XMLConfigUtil.saveDocumentToFile(doc, filePath);
                }
                else
                {
                    throw new UserException("user doesn't exist!");
                }
            }
            if (op.equals("add"))
            {                 if (exist)
                {
                    throw new UserException("user already exist!");
                }
                else
                {
                    String password = form.getPassword();
                    Element element = XMLConfigUtil.newElement(doc, null
                        , "user", null);
                    XMLConfigUtil.setTextByPath(doc, element, "username", null, null
                        , username);
                    XMLConfigUtil.setTextByPath(doc, element, "password", null, null
                        , password);
                    XMLConfigUtil.setTextByPath(doc, element, "remark", null, null
                        , remark);
                    XMLConfigUtil.setTextByPath(doc, element, "email", null, null
                        , email);
                    if(xlinker==null)
                    {
                    	for(int k=0 ;k<xlinker.size();k++)
                    	{
                    		XMLConfigUtil.setTextByPath(doc, ele, "purview/WSRumtime/name", null, null
                    				 ,((ServerInfoMeta)(xlinker.get(k))).getName());
                        	XMLConfigUtil.setTextByPath(doc, ele, "purview/WSRumtime/pv", null, null
                                    ,((ServerInfoMeta)(xlinker.get(k))).getPurview());
                    	}
                                                       
                    }
                    else
                    {
                    	XMLConfigUtil.setTextByPath(doc, ele, "purview/Xlinker", null, null
                                , "");
                    }
                    if(workflow==null)
                    {
                    	for(int k=0 ;k<workflow.size();k++)
                    	{
                    		XMLConfigUtil.setTextByPath(doc, ele, "purview/WSRumtime/name", null, null
                    				 ,((ServerInfoMeta)(workflow.get(k))).getName());
                        	XMLConfigUtil.setTextByPath(doc, ele, "purview/WSRumtime/pv", null, null
                                    ,((ServerInfoMeta)(workflow.get(k))).getPurview());
                    	}
                                                       
                    }
                    else
                    {
                    	XMLConfigUtil.setTextByPath(doc, ele, "purview/Xlinker", null, null
                                , "");
                    }
                    
                    XMLConfigUtil.setTextByPath(doc, element, "purview/top", null, null
                        , new Boolean(top).toString());
                    XMLConfigUtil.saveDocumentToFile(doc, filePath);
                }
            }
        }
        catch (Exception ex)
        {
                        String backUrl = "user/userEdit.jsp";
            request.getSession().setAttribute("Util_FailBackPage", backUrl);
            String tmp = AdminResBundle.getMessage("user.error.usersave");
            tmp += " "+ex.getMessage();
            request.getSession().setAttribute("Util_ErrorInfo", tmp);
            request.getSession().setAttribute("Util_ErrorDetail"
                                              , Utils.FormatExceptionToHtml(ex));
            return mapping.findForward("Failure");
        }
        String tmp = AdminResBundle.getMessage("user.success.usersave");
        request.getSession().setAttribute("Util_SucInfo", tmp);
                        request.getSession().setAttribute("Util_SucBackUrl", "user/personInfoEdit.jsp");
                return mapping.findForward("Success");
    }
}
