
package org.act.manage.util;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class AdminResBundle {
	static ResourceBundle myResources = ResourceBundle
			.getBundle("ApplicationResources");
	
	public static String getMessage(String key) {
		try {
			String rs = new String(myResources.getString(key));
			return rs;
		} catch (Exception ex) {
			return null;
		}
	}
	
	public static String getMessage(String key, String[] args) {
		try {
			String rs = new String(myResources.getString(key));
			return java.text.MessageFormat.format(rs, args);
		} catch (Exception ex) {
			return null;
		}
	}
	
	public static String getMessage(String key, String arg)
			throws MissingResourceException {
		String[] args = { arg };
		return getMessage(key, args);
	}
	
	public static String getMessage(String key, String arg1, String arg2)
			throws MissingResourceException {
		String[] args = { arg1, arg2 };
		return getMessage(key, args);
	}
	
	public static String getMessage(String key, String arg1, String arg2,
			String arg3) throws MissingResourceException {
		String[] args = { arg1, arg2, arg3 };
		return getMessage(key, args);
	}
}
