
package org.act.manage.util;
import java.util.Vector;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class ServerInfo {
	public static ServerInfoMeta getServerAddress(String serverName,String serverType)
	{
		ServerInfoMeta serverInfoM =new ServerInfoMeta();
		try {
			
			Document doc = XMLConfigUtil.loadDocumentFromFile(Utils.mServerConfigFile);
			
			Vector serverEles = XMLConfigUtil.getElement(doc, null, serverType, null);
			Element serverEle = null;
            for (int i = 0; i < serverEles.size(); i++) {
				serverEle = (Element) serverEles.get(i);
				if (serverName.equals(XMLConfigUtil.getTextByPath(doc,
						serverEle, "name", null, null)))
					break;
			}
            if (serverEle == null)
                throw new Exception("No Server");
            if(serverType.equals("WorkflowEngine"))
            {
            	serverInfoM.setName(XMLConfigUtil.getTextByPath(doc,
						serverEle, "name", null, null));
            	serverInfoM.setAddress(XMLConfigUtil.getTextByPath(doc,
						serverEle, "address", null, null));
            	System.setProperty("Driver", XMLConfigUtil.getTextByPath(doc,serverEle, "Driver", null, null));
            	serverInfoM.setDBaddress(XMLConfigUtil.getTextByPath(doc,
						serverEle, "DBaddress", null, null));
            	serverInfoM.setDBUser(XMLConfigUtil.getTextByPath(doc,
						serverEle, "DBUser", null, null));
            	if(XMLConfigUtil.getTextByPath(doc,
						serverEle, "DBPWD", null, null)==null)
            	{
            		serverInfoM.setDBPWD("");
            	}
            	else
            		serverInfoM.setDBPWD(XMLConfigUtil.getTextByPath(doc,
    						serverEle, "DBPWD", null, null));
            }
            else if (serverType.equals("WSRuntime")) {
            	serverInfoM.setName(XMLConfigUtil.getTextByPath(doc,
						serverEle, "name", null, null));
            	serverInfoM.setAddress(XMLConfigUtil.getTextByPath(doc,
						serverEle, "address", null, null));
				
			}
            else 
            {
            	throw new Exception("No serverType");
            }
            
            		
		} catch (Exception e) {
						e.printStackTrace();
		}
		return serverInfoM;
		
	}
	public static void main(String[] args) {
	}
}
