
package org.act.manage.workflow.db;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import org.act.manage.util.ConnectionDB;

public class SuperContextInfo {
	public SuperContextInfo() {
    }
    
    public Vector queryInfo(String transactionID){
                Vector superContextInfo = new Vector();
                List compensationAddrList = new ArrayList();
        String sqlQuery = "select * from SuperContextInfoTable where TransactionID = '"+
            transactionID +"'";
        try {
            Connection connection =  new ConnectionDB().getConnection();
            Statement statement = connection.createStatement();
            ResultSet resultset = statement.executeQuery(sqlQuery);
            ResultSetMetaData metadata = resultset.getMetaData();
            while (resultset.next()) {
                compensationAddrList.clear();
                                String address = "";
                                StringBuffer addressList = new StringBuffer();
                for (int i = 2; i < metadata.getColumnCount(); i++)
                    superContextInfo.addElement(resultset.getObject(i));
                addressList.append(resultset.getString("CompensationAddrList"));
                while (addressList.length() > 0){
                                        int separator = addressList.indexOf("/");
                    address = addressList.substring(0, separator);
                    compensationAddrList.add(address);
                    addressList = addressList.delete(0, separator + 1);
                }
                superContextInfo.add(compensationAddrList);
            }
            resultset.close();
            statement.close();
            connection.close();
        }
        catch (SQLException ex) {
            System.out.println(ex.getMessage());
        }
        return superContextInfo;
    }
    
    public boolean insert(String transactionID, String superiorID,
                          String superiorAddress, String transactionStatus,
                          boolean isAtom, boolean isTopTransaction,
                          List compensationAddrList){
                String address = "";
                StringBuffer addressList = new StringBuffer();
        for (Iterator iter = compensationAddrList.iterator(); iter.hasNext(); ) {
            address = iter.next().toString();
            addressList.append(address);
            addressList.append("/");
        }
        String sqlInsert = "insert into SuperContextInfoTable" +
            "(TransactionID,SuperiorID,SuperiorAddress,TransactionStatus,"+
            "IsAtom,IsTopTransaction,CompensationAddrList) values('"+
            transactionID +"','"+ superiorID +"','"+ superiorAddress +"','"+
            transactionStatus +"',"+ isAtom +","+ isTopTransaction +",'"+
            addressList.toString() +"')";
        try{
            Connection connection =  new ConnectionDB().getConnection();
            Statement statement = connection.createStatement();
            statement.executeUpdate(sqlInsert);
            statement.close();
            connection.close();
            return true;
        }
        catch(SQLException ex){
            System.out.println(ex.getMessage());
            return false;
        }
    }
    
    public boolean delete(String transactionID){
        String sqlDelete = "delete from SuperContextInfoTable where " +
           "TransactionID = '"+ transactionID +"'";
        try{
            Connection connection =  new ConnectionDB().getConnection();
            Statement statement = connection.createStatement();
            statement.executeUpdate(sqlDelete);
            statement.close();
            connection.close();
            return true;
        }
        catch(SQLException ex){
            System.out.println(ex.getMessage());
            return false;
        }
    }
}
