
package org.act.manage.workflow.instance;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Vector;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.namespace.QName;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.CallWfEngine;
import org.act.manage.util.ServerInfo;
import org.act.manage.util.Utils;
import org.act.manage.workflow.meta.TransactionInfoMeta;
import org.act.manage.wsruntime.meta.InferiorInfoMeta;
import org.act.soap.util.TMConstants;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class TransactionNowInfoAction extends Action {
	private boolean needUpdateTree = false;
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		String txID = "";
		try {
			ArrayList al = new ArrayList();
												txID = request.getParameter("txID");
									String transaction = null;
			;
																					String serverType = (String) request.getSession().getAttribute(
					"ServerType");
			String server = (String) request.getSession()
					.getAttribute("Server");
			String uri = ServerInfo.getServerAddress(server, serverType)
					.getAddress();
			String result = "";
			result = (String) CallWfEngine.invoke("getTransactionInfo", uri,
					TMConstants.XSD_STRING,
					new QName[] { javax.xml.rpc.encoding.XMLType.XSD_STRING },
					new Object[] { txID });
			TransactionInfoMeta info = new TransactionInfoMeta();
			String txInfo[] = result.split("#");
															info.setTxID(txID);
			info.setBeginTime(this.transferTime(txInfo[0]));
			if (null == txInfo[1] || txInfo[1].equals("")
					|| txInfo[1].equals("0"))
				info.setConfirmTime(" ");
			else
				info.setConfirmTime(this.transferTime(txInfo[1]));
			
			if (null == txInfo[2] || txInfo[2].equals("")
					|| txInfo[2].equals("0"))
				info.setPreparedTime(" ");
			else
				info.setPreparedTime(this.transferTime(txInfo[2]));
			
			if (null == txInfo[3] || txInfo[3].equals("")
					|| txInfo[3].equals("0"))
				info.setEndTime(" ");
			else
				info.setEndTime(this.transferTime(txInfo[3]));
			
			info.setTransactionStatus(makeStatusString(txInfo[4]));
			info.setOwnerID(txInfo[5]);
			al.add(info);
						request.getSession().setAttribute("WF_TransactionList", al);
						ArrayList alInferior = new ArrayList();
						if (txInfo.length>6)
			{
				String inferior[]=txInfo[6].split("~");
	
								Vector oneInfo;
				for (int i = 0; i < inferior.length/10; i++) {
										InferiorInfoMeta infoI = new InferiorInfoMeta();
					infoI.setInferiorID(inferior[i*10+2]);
					infoI.setInferiorAddress(inferior[i*10+3]);
					infoI.setInferiorStatus(makeStatusString(inferior[i*10+1]));
					infoI.setCanceltime_b(transferTime(inferior[i*10+4]));
					infoI.setCanceltime_e(transferTime(inferior[i*10+5]));
					infoI.setConfirmtime_b(transferTime(inferior[i*10+6]));
					infoI.setConfirmtime_e(transferTime(inferior[i*10+7]));
					infoI.setPreparetime_b(transferTime(inferior[i*10+8]));
					infoI.setPreparetime_e(transferTime(inferior[i*10+9]));
					alInferior.add(infoI);
				}
			}
						request.getSession().setAttribute("WF_InferiorList", alInferior);
			setHistorySession(request, txID);
		} catch (Exception ex) {
						request.getSession()
					.setAttribute("Util_FailBackPage", "/blank.jsp");
			String tmp = AdminResBundle.getMessage("wf.process.error.tranList",
					txID);
			tmp += " " + ex.getMessage();
			request.getSession().setAttribute("Util_ErrorInfo", tmp);
			request.getSession().setAttribute("Util_ErrorDetail",
					Utils.FormatExceptionToHtml(ex));
			return mapping.findForward("Failure");
		}
		if (needUpdateTree) {
			needUpdateTree = false;
			request.getSession().setAttribute("Util_AfterUpdateTree",
					"/transaction/suInfo.jsp");
			return mapping.findForward("UpdateTree");
		} else
			return mapping.findForward("Forward");
	}
		private void setHistorySession(HttpServletRequest request, String ID) {
		String hisTxID = (String) request.getSession().getAttribute(
				"WF_History_TransactionID");
		if (hisTxID == null || !hisTxID.equals(ID)) {
			request.getSession().setAttribute("WF_History_TransactionID", ID);
												needUpdateTree = true;
		}
	}
		private String makeStatusString(String status) {
				if (status.equalsIgnoreCase("Begun"))
			return AdminResBundle
					.getMessage("wf.process.table.status.transaction.Begun");
		else if (status.equalsIgnoreCase("Confirmed"))
			return AdminResBundle
					.getMessage("wf.process.table.status.transaction.Confirmed");
		else if (status.equalsIgnoreCase("Cancelled"))
			return AdminResBundle
					.getMessage("wf.process.table.status.transaction.Canceled");
		else if (status.equalsIgnoreCase("true"))
			return AdminResBundle
					.getMessage("wf.process.table.status.transaction.true");
		else if (status.equalsIgnoreCase("false"))
			return AdminResBundle
					.getMessage("wf.process.table.status.transaction.false");
		else if (status.equalsIgnoreCase("Active"))
			return AdminResBundle
					.getMessage("wf.process.table.status.inferior.Active");
		else if (status.equalsIgnoreCase(""))
			return " ";
		else
			return status;
	}
		private  String transferTime(String timeOrg) {
		if(timeOrg==null||timeOrg.equals(""))
			return "";
		long a = Long.parseLong(timeOrg);
		Date datea = new Date();
		datea.setTime(a);
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
		String timea = sdf.format(datea).toString();
		return timea;
	}
}
