
package org.act.manage.workflow.process;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.bpeldata.Assign;
import org.act.wsc.bpel4wsmodeling.bpeldata.Case;
import org.act.wsc.bpel4wsmodeling.bpeldata.Compensate;
import org.act.wsc.bpel4wsmodeling.bpeldata.Empty;
import org.act.wsc.bpel4wsmodeling.bpeldata.Flow;
import org.act.wsc.bpel4wsmodeling.bpeldata.Invoke;
import org.act.wsc.bpel4wsmodeling.bpeldata.OnAlarm;
import org.act.wsc.bpel4wsmodeling.bpeldata.OnMessage;
import org.act.wsc.bpel4wsmodeling.bpeldata.OtherWise;
import org.act.wsc.bpel4wsmodeling.bpeldata.Pick;
import org.act.wsc.bpel4wsmodeling.bpeldata.Receive;
import org.act.wsc.bpel4wsmodeling.bpeldata.Reply;
import org.act.wsc.bpel4wsmodeling.bpeldata.Scope;
import org.act.wsc.bpel4wsmodeling.bpeldata.Sequence;
import org.act.wsc.bpel4wsmodeling.bpeldata.Switch;
import org.act.wsc.bpel4wsmodeling.bpeldata.Terminate;
import org.act.wsc.bpel4wsmodeling.bpeldata.Throw;
import org.act.wsc.bpel4wsmodeling.bpeldata.Transaction;
import org.act.wsc.bpel4wsmodeling.bpeldata.Wait;
import org.act.wsc.bpel4wsmodeling.bpeldata.While;

public final class DataFactory {
  public static int getTypeByServicessSet(Metaset ss) {
    if (ss instanceof Invoke) {
      return Svg.LABLE_INVOKE;
    }
    else if (ss instanceof Receive) {
      return Svg.LABLE_RECEIVE;
    }
    else if (ss instanceof Reply) {
      return Svg.LABLE_REPLY;
    }
    else if (ss instanceof Assign) {
      return Svg.LABLE_ASSIGN;
    }
    else if (ss instanceof Empty) {
      return Svg.LABLE_EMPTY;
    }
    else if (ss instanceof Terminate) {
      return Svg.LABLE_TERMINATE;
    }
    else if (ss instanceof Throw) {
      return Svg.LABLE_THROW;
    }
    else if (ss instanceof Wait) {
      return Svg.LABLE_WAIT;
    }
    else if (ss instanceof Compensate) {
      return Svg.LABLE_COMPENSATE;
    }
    else if (ss instanceof Sequence) {
      return Svg.LABLE_SEQUENCE;
    }
    else if (ss instanceof Scope) {
      return Svg.LABLE_SCOPE;
    }
    else if (ss instanceof While) {
      return Svg.LABLE_WHILE;
    }
    else if (ss instanceof Pick) {
      return Svg.LABLE_PICK;
    }
    else if (ss instanceof Switch) {
      return Svg.LABLE_SWITCH;
    }
    else if (ss instanceof Flow) {
      return Svg.LABLE_FLOW;
    }
    else if (ss instanceof Case) {
      return Svg.LABLE_CASE;
    }
    else if (ss instanceof OtherWise) {
      return Svg.LABLE_OTHERWISE;
    }
    else if (ss instanceof OnAlarm) {
      return Svg.LABLE_ONALARM;
    }
    else if (ss instanceof OnMessage) {
      return Svg.LABLE_ONMESSAGE;
    }else if(ss instanceof Transaction){
        return Svg.LABLE_TRANSACTION;
    }
    else {
      return -1;
    }
  }
}
