
package org.act.manage.workflow.process;
import java.awt.Color;
import java.awt.Point;
import java.util.ArrayList;
import java.util.Vector;
import org.act.manage.workflow.meta.ActivityInfoMeta;
import org.act.metaset.Attribute;
import org.act.metaset.Metaset;
import org.act.wsc.bpel4wsmodeling.bpeldata.Assign;
import org.act.wsc.bpel4wsmodeling.bpeldata.Case;
import org.act.wsc.bpel4wsmodeling.bpeldata.Compensate;
import org.act.wsc.bpel4wsmodeling.bpeldata.Empty;
import org.act.wsc.bpel4wsmodeling.bpeldata.Flow;
import org.act.wsc.bpel4wsmodeling.bpeldata.Invoke;
import org.act.wsc.bpel4wsmodeling.bpeldata.OnAlarm;
import org.act.wsc.bpel4wsmodeling.bpeldata.OnMessage;
import org.act.wsc.bpel4wsmodeling.bpeldata.OtherWise;
import org.act.wsc.bpel4wsmodeling.bpeldata.Pick;
import org.act.wsc.bpel4wsmodeling.bpeldata.Receive;
import org.act.wsc.bpel4wsmodeling.bpeldata.Reply;
import org.act.wsc.bpel4wsmodeling.bpeldata.Scope;
import org.act.wsc.bpel4wsmodeling.bpeldata.Sequence;
import org.act.wsc.bpel4wsmodeling.bpeldata.Switch;
import org.act.wsc.bpel4wsmodeling.bpeldata.Terminate;
import org.act.wsc.bpel4wsmodeling.bpeldata.Throw;
import org.act.wsc.bpel4wsmodeling.bpeldata.Transaction;
import org.act.wsc.bpel4wsmodeling.bpeldata.Wait;
import org.act.wsc.bpel4wsmodeling.bpeldata.While;
import org.act.wsc.bpel4wsmodeling.projectdata.Figure;
import org.act.wsc.bpel4wsmodeling.projectdata.StructFigure;

public class Svg extends Identifier {
	
	public static final int LABLE_SWITCH = 13;
	public static final int LABLE_CASE = 131;
	public static final int LABLE_OTHERWISE = 132;
	public static final int LABLE_WHILE = 14;
	public static final int LABLE_PICK = 15;
	public static final int LABLE_ONMESSAGE = 151;
	public static final int LABLE_ONALARM = 152;
	public static final int LABLE_FLOW = 16;
	public static final int LABLE_SCOPE = 17;
	public static final int LABLE_SEQUENCE = 18;
	public static final int LABLE_JOINEND = 19;
	public static final int LABLE_THROW = 20;
	public static final int LABLE_EMPTY = 21;
	public static final int LABLE_WAIT = 22;
	public static final int LABLE_FRAME = 23;
	public static final int LABLE_COMPENSATE = 2;
	public static final int LABLE_TERMINATE = 3;
	public static final int LABLE_INVOKE = 4;
	public static final int LABLE_RECEIVE = 5;
	public static final int LABLE_REPLY = 6;
	public static final int LABLE_ASSIGN = 7;
	public static final int LABLE_NOMINAL = 0;
	public static final int LABLE_TRANSACTION = 231;
	public static final int LABLE_TRANSACTIONEND = 232;
	
	public static final int LINE_HEIGHT = 10;	public static final int LINE_WIDTH = 10;
			
			protected int width = 0;
	protected int height = 0;
	protected int structWidth = 0;
	protected int structHeight = 0;
	protected int type = 0;
				protected Svg parent = null;
	private ArrayList childs = null;
		protected Metaset svgSS = null;		protected String name = "";
	protected int x = 0;
	protected int y = 0;
	protected String icon;
	private ArrayList al = null;
	protected Svg() {
	}
	public Svg(int type) {
	}
	protected Svg(int x, int y, int type) {
	}
	public void CreateSvg() {
		Metaset s = new Metaset("use");
		Attribute x = new Attribute("x", String.valueOf(this.x));
		Attribute y = new Attribute("y", String.valueOf(this.y));
		Attribute xlinkhref = new Attribute("xlink:href", "#" + icon);
		if (this.name != null && !this.name.equals("")) {
			Attribute name = new Attribute("id", this.name);
			s.add(name);
			if (this.al != null) {
				ActivityInfoMeta oneInfo;
	            for (int i = 0; i < al.size(); i++)
	            {
	                oneInfo = (ActivityInfoMeta)al.get(i);
	                if(this.name.equals(oneInfo.getName())){
	                	Attribute beginTime = new Attribute("beginTime", oneInfo.getBeginTime());
	            		Attribute endTime = new Attribute("endTime", oneInfo.getEndTime());
	            		Attribute type=new Attribute("type", oneInfo.getType());
	            		Attribute status=new Attribute("status", oneInfo.getStatus());
	            		xlinkhref=new Attribute("xlink:href", "#" + icon+"_"+oneInfo.getStatus());
	            		s.add(beginTime);
	            		s.add(endTime);
	            		s.add(type);
	            		s.add(status);
	            		
	            		if(oneInfo.getTxID()!=null)
	            		{
	            			Attribute txid=new Attribute("txid", oneInfo.getTxID());
	            			s.add(txid);
	            		}
	            		break;
	            		
	                }
	                
	                
	               
	               
				}
			}
		}
		s.add(x);
		s.add(y);
		s.add(xlinkhref);
		svgSS.add(new Attribute("type", type + ""));
		svgSS.add(s);
	}
	public void addJoint(int type, String icon, int x, int y) {
		Metaset s = new Metaset("use");
		Attribute ax = new Attribute("x", String.valueOf(x));
		Attribute ay = new Attribute("y", String.valueOf(y));
		Attribute xlinkhref = new Attribute("xlink:href", "#" + icon);
				s.add(ax);
		s.add(ay);
		s.add(xlinkhref);
						svgSS.add(s);
	}
	public void AddBorder(StructFigure structFigure) {
		int dy = 0;
		if (structFigure.getEnd() != null) {
			dy = structFigure.getEnd().getHeight() / 2;
		}
		Point[] points = new Point[6];
		points[0] = new Point(x, y + height / 2);
		points[1] = new Point(x + width / 2 - structWidth / 2, y + height / 2);
		points[2] = new Point(x + width / 2 - structWidth / 2, y + structHeight
				- dy);
		points[3] = new Point(x + width / 2 + structWidth / 2, y + structHeight
				- dy);
		points[4] = new Point(x + width / 2 + structWidth / 2, y + height / 2);
		points[5] = new Point(x + width, y + height / 2);
		for (int i = 0; i < points.length - 1; i++) {
			Point p1 = points[i];
			Point p2 = points[i + 1];
			this.DrawLine(p1.x, p1.y, p2.x, p2.y);
		}
	}
	public Svg(Figure f) {
		svgSS = new Metaset("g");
		Metaset ss = f.getServicesSet();
		if (ss instanceof Sequence) {
			
			setType(LABLE_SEQUENCE);
			setIcon("Sequence");
			setWidth(60);
			setHeight(37);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof Scope) {
			setType(LABLE_SCOPE);
			setIcon("Scope");
			setWidth(60);
			setHeight(57);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof While) {
			setType(LABLE_WHILE);
			setIcon("While");
			setWidth(40);
			setHeight(39);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof Pick) {
			setType(LABLE_PICK);
			setIcon("Pick");
			setWidth(32);
			setHeight(37);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof Switch) {
			setType(LABLE_SWITCH);
			setIcon("Switch");
			setWidth(45);
			setHeight(48);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof Flow) {
			setType(LABLE_FLOW);
			setIcon("Flow");
			setWidth(35);
			setHeight(37);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof Case) {
			setType(LABLE_CASE);
			setIcon("Case");
			setWidth(59);
			setHeight(19);
			this.setX(f.getX() - f.getWidth() / 2);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof OtherWise) {
			setType(LABLE_OTHERWISE);
			setIcon("OtherWise");
			setWidth(83);
			setHeight(18);
			this.setX(f.getX() - f.getWidth() / 2);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof OnAlarm) {
			setType(LABLE_ONALARM);
			setIcon("OnAlarm");
			setWidth(77);
			setHeight(19);
			this.setX(f.getX() - f.getWidth() / 2);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof OnMessage) {
			setType(LABLE_ONMESSAGE);
			setIcon("OnMessage");
			setWidth(92);
			setHeight(18);
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Transaction) {
			setType(LABLE_TRANSACTION);
			setIcon("Transaction");
			setWidth(46);
			setHeight(39);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
					} else if (ss instanceof Invoke) {
			setType(LABLE_INVOKE);
			setIcon("Invoke");
			setWidth(46);
			setHeight(39);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Receive) {
			setType(LABLE_RECEIVE);
			setIcon("Receive");
			setWidth(51);
			setHeight(38);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Reply) {
			setType(LABLE_REPLY);
			setIcon("Reply");
			setWidth(40);
			setHeight(38);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Assign) {
			setType(LABLE_ASSIGN);
			setIcon("Assign");
			setWidth(44);
			setHeight(37);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Empty) {
			setType(LABLE_EMPTY);
			setIcon("Empty");
			setWidth(43);
			setHeight(38);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Terminate) {
			setType(LABLE_TERMINATE);
			setIcon("Terminate");
			setWidth(82);
			setHeight(58);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Throw) {
			setType(LABLE_THROW);
			setIcon("Throw");
			setWidth(43);
			setHeight(38);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Wait) {
			setType(LABLE_WAIT);
			setIcon("Wait");
			setWidth(35);
			setHeight(39);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Compensate) {
						setType(LABLE_COMPENSATE);
			setIcon("Compensate");
														}
					}
	public Svg(Figure f, ArrayList al) {
		this.al = al;
		svgSS = new Metaset("g");
		Metaset ss = f.getServicesSet();
		if (ss instanceof Sequence) {
			
			setType(LABLE_SEQUENCE);
			setIcon("Sequence");
			setWidth(60);
			setHeight(37);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof Scope) {
			setType(LABLE_SCOPE);
			setIcon("Scope");
			setWidth(60);
			setHeight(57);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof While) {
			setType(LABLE_WHILE);
			setIcon("While");
			setWidth(40);
			setHeight(39);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof Pick) {
			setType(LABLE_PICK);
			setIcon("Pick");
			setWidth(32);
			setHeight(37);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof Switch) {
			setType(LABLE_SWITCH);
			setIcon("Switch");
			setWidth(45);
			setHeight(48);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof Flow) {
			setType(LABLE_FLOW);
			setIcon("Flow");
			setWidth(35);
			setHeight(37);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
			this.addJoint(LABLE_JOINEND, "Joinend", ((StructFigure) f).getEnd()
					.getX()
					- ((StructFigure) f).getEnd().getWidth() / 2,
					((StructFigure) f).getEnd().getY());
			this.AddBorder((StructFigure) f);
					} else if (ss instanceof Case) {
			setType(LABLE_CASE);
			setIcon("Case");
			setWidth(59);
			setHeight(19);
			this.setX(f.getX() - f.getWidth() / 2);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof OtherWise) {
			setType(LABLE_OTHERWISE);
			setIcon("OtherWise");
			setWidth(83);
			setHeight(18);
			this.setX(f.getX() - f.getWidth() / 2);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof OnAlarm) {
			setType(LABLE_ONALARM);
			setIcon("OnAlarm");
			setWidth(77);
			setHeight(19);
			this.setX(f.getX() - f.getWidth() / 2);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof OnMessage) {
			setType(LABLE_ONMESSAGE);
			setIcon("OnMessage");
			setWidth(92);
			setHeight(18);
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Transaction) {
			setType(LABLE_TRANSACTION);
			setIcon("Transaction");
			setWidth(46);
			setHeight(39);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
					} else if (ss instanceof Invoke) {
			setType(LABLE_INVOKE);
			setIcon("Invoke");
			setWidth(46);
			setHeight(39);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Receive) {
			setType(LABLE_RECEIVE);
			setIcon("Receive");
			setWidth(51);
			setHeight(38);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Reply) {
			setType(LABLE_REPLY);
			setIcon("Reply");
			setWidth(40);
			setHeight(38);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Assign) {
			setType(LABLE_ASSIGN);
			setIcon("Assign");
			setWidth(44);
			setHeight(37);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Empty) {
			setType(LABLE_EMPTY);
			setIcon("Empty");
			setWidth(43);
			setHeight(38);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Terminate) {
			setType(LABLE_TERMINATE);
			setIcon("Terminate");
			setWidth(82);
			setHeight(58);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Throw) {
			setType(LABLE_THROW);
			setIcon("Throw");
			setWidth(43);
			setHeight(38);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Wait) {
			setType(LABLE_WAIT);
			setIcon("Wait");
			setWidth(35);
			setHeight(39);
			this.setStructHeight(f.getStructHeight());
			this.setStructWidth(f.getStructWidth());
			this.setX(f.getX() - f.getWidth() / 2);
			this.setY(f.getY());
			this.setName(ss.selector(".\\", "name"));
			this.CreateSvg();
		} else if (ss instanceof Compensate) {
						setType(LABLE_COMPENSATE);
			setIcon("Compensate");
														}
					}
	
	public Svg getParent() {
		return parent;
	}
	
	public void setParent(Svg parent) {
		this.parent = parent;
	}
	
	public int getType() {
		return type;
	}
	
	public void setType(int type) {
		this.type = type;
	}
	
	public int getHeight() {
		return height;
	}
	
	public int getWidth() {
		return width;
	}
	public int getStructHeight() {
		return structHeight;
	}
	
	public int getStructWidth() {
		return structWidth;
	}
	
	public void setStructHeight(int structHeight) {
		this.structHeight = structHeight;
	}
	
	public void setStructWidth(int structWidth) {
		this.structWidth = structWidth;
	}
	public void setFrameSize() {
				if (this.structWidth == 0) {
			this.structWidth = this.width;
		}
		if (this.structHeight == 0) {
			this.structHeight = this.height;
		}
	}
	public void setHeight(int height) {
		this.height = height;
	}
	public void setWidth(int width) {
		this.width = width;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		if (name != null)
			this.name = name;
	}
	
	public int getX() {
		return x;
	}
	
	public void setX(int x) {
		this.x = x;
	}
	
	public int getY() {
		return y;
	}
	
	public void setY(int y) {
		this.y = y;
	}
	
	public String getIcon() {
		return icon;
	}
	
	public void setIcon(String icon) {
		this.icon = icon;
	}
	public void addFrame(Svg subSvg) {
				int subFrameHeight = subSvg.structHeight;
		int subFrameWidth = subSvg.structWidth;
		int frameHeight = getStructHeight();		int frameWidth = getStructWidth();		if (this.type == LABLE_PICK || this.type == LABLE_SWITCH
				|| this.type == LABLE_FLOW) {
			frameHeight = Math.max(frameHeight, subFrameHeight + this.height
					+ LINE_HEIGHT * 2);
			if (frameWidth == this.width) {
				frameWidth = subFrameWidth + LINE_WIDTH * 2;
			} else {
				frameWidth += subFrameWidth;
				frameWidth += LINE_WIDTH * 2;
			}
		} else if (this.type == LABLE_SEQUENCE) {
			frameWidth = Math.max(frameWidth, subFrameWidth) + LINE_WIDTH * 2;
																		frameHeight += subFrameHeight;
			frameHeight += LINE_HEIGHT * 2;
		} else if (this.type == LABLE_SCOPE || this.type == LABLE_WHILE
				|| this.type == LABLE_CASE || this.type == LABLE_OTHERWISE
				|| this.type == LABLE_ONALARM || this.type == LABLE_ONMESSAGE
				|| this.type == LABLE_TRANSACTION) {
			frameHeight += (subFrameHeight + LINE_HEIGHT * 2);
			frameWidth = Math.max(frameWidth, subFrameWidth) + LINE_WIDTH * 2;
		}
		this.setStructHeight(frameHeight);
		this.setStructWidth(frameWidth);
		if (this.type == LABLE_SEQUENCE || this.type == LABLE_SCOPE
				|| this.type == LABLE_WHILE || this.type == LABLE_PICK
				|| this.type == LABLE_SWITCH || this.type == LABLE_FLOW
				|| this.type == LABLE_TRANSACTION) {
			addFrame(this.structWidth, this.structHeight, svgSS);
		}
	}
	private void addFrame(int structWidth, int structHeight, Metaset structSvg) {
				Metaset s = new Metaset("use");
		Attribute sid = getId();
						Attribute width = new Attribute("width", structWidth + "");
		Attribute height = new Attribute("height", structHeight + "");
		Attribute xlinkhref = new Attribute("xlink:href", "#frame");
		structSvg.add(sid);
						s.add(width);
		s.add(height);
		s.add(xlinkhref);
		svgSS.add(new Attribute("type", LABLE_FRAME + ""));
		structSvg.add(s);
	}
	public void DrawLine(int x1, int y1, int x2, int y2) {
				Metaset SS = new Metaset("line");
		Attribute ax1 = new Attribute("x1", String.valueOf(x1));
		Attribute ay1 = new Attribute("y1", String.valueOf(y1));
		Attribute ax2 = new Attribute("x2", String.valueOf(x2));
		Attribute ay2 = new Attribute("y2", String.valueOf(y2));
		Attribute fill = new Attribute("fill", "none");
		Attribute stroke = new Attribute("stroke", "rgb(0,0,0)");
		Attribute strokeWidth = new Attribute("stroke_width", "1");
		SS.add(fill);
		SS.add(stroke);
		SS.add(strokeWidth);
		SS.add(ax1);
		SS.add(ay1);
		SS.add(ax2);
		SS.add(ay2);
		svgSS.add(SS);
	}
}
