
package org.act.manage.wsruntime.config;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.namespace.QName;
import org.act.manage.util.AdminResBundle;
import org.act.manage.util.CallServer;
import org.act.manage.util.CallWfEngine;
import org.act.manage.util.ServerInfo;
import org.act.manage.util.Utils;
import org.act.soap.util.TMConstants;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class ConfigEditAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		String backUrl = "/blank.jsp";
		try {
						String serverType = (String) request.getSession().getAttribute(
					"ServerType");
			String server = (String) request.getSession()
					.getAttribute("Server");
			String uri = ServerInfo.getServerAddress(server, serverType)
					.getAddress();
			String text="";
			if (serverType.equals("WSRuntime")) {
				try {
					text = (String) CallServer
							.invoke(
									"getConfigFile",
									uri,
									TMConstants.XSD_STRING,
									new QName[] {  },
									new Object[] {  });
					
				} catch (Exception e) {
					e.printStackTrace();
				}
			} else if (serverType.equals("WorkflowEngine")) {
				try {
					text = (String) CallWfEngine
							.invoke(
									"getConfigFile",
									uri,
									TMConstants.XSD_STRING,
									new QName[] {  },
									new Object[] {  });
					
				} catch (Exception e) {
					e.printStackTrace();
				}
			} else {
				return mapping.findForward("Fail");
			}
			String confFile = "ok";
									ConfigForm confForm = new ConfigForm();
			confForm.setText(text);
						request.getSession().setAttribute("configForm", confForm);
		} catch (Exception ex) {
			request.getSession().setAttribute("Util_FailBackPage", backUrl);
			String tmp = AdminResBundle.getMessage("wf.config.error.edit");
			tmp += " " + ex.getMessage();
			request.getSession().setAttribute("Util_ErrorInfo", tmp);
			request.getSession().setAttribute("Util_ErrorDetail",
					Utils.FormatExceptionToHtml(ex));
			return mapping.findForward("Failure");
		}
		return mapping.findForward("Forward");
	}
}
