
package org.act.manage.wsruntime.service;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.act.manage.util.CallServer;
import org.act.manage.util.ServerInfo;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

public class GetWsddAction extends Action {
    public ActionForward execute(ActionMapping mapping,
            ActionForm form,
            HttpServletRequest request,
            HttpServletResponse response)
    throws ServletException
	{
				String serviceName = request.getParameter("service");
		
		
		try {
			String serverType=(String)request.getSession().getAttribute("ServerType");
			String server=(String)request.getSession().getAttribute("Server");
			CallServer callServer=new CallServer
			(ServerInfo.getServerAddress(server,serverType).getAddress());
		String result="";
		try{
			result=callServer.testgetWsdd(serviceName);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		
		request.setAttribute("wsdd",result);
		} 
		catch(Throwable e) {
		request.getSession().setAttribute("Util_FailBackPage", "/blank.jsp");
		e.printStackTrace();
		return mapping.findForward("Failure");
		}
		
				
		request.setAttribute("serviceName", serviceName);
		
				return mapping.findForward("ServiceWSDD");
	}
}
