<!-- Standard Struts Entries -->

<%@ page language="java" contentType="text/html;charset=utf-8" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/controls.tld" prefix="controls"%>

<html:html locale="true">

  <%@ include file="../header.jsp" %>

  <controls:body>

    <%-- display warnings if any --%>
    <logic:present name="warning">
        <center>
            <h4>
                <font color="red"><bean:message key="warning.header"/></font>
                <bean:message key='<%= (String) request.getAttribute("warning") %>'/>
            </h4>
        </center>
        <br>
    </logic:present>

    <center><h2>
      <bean:message key="instance.deploy.failed"/>
    </h2></center>

    <%@ include file="../footer.jsp" %>

  </controls:body>

</html:html>
